package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._connectionManagerImplBase
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_connectionManagerImplBase.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionManager {
      ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
        in string arg0
      );
      void compute(
        in string arg0
      );
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
    };
</pre>
</p>
*/
abstract public class _connectionManagerImplBase extends org.omg.CORBA.portable.Skeleton implements edu.syr.npac.webflow.connection.connectionManager {
  protected edu.syr.npac.webflow.connection.connectionManager _wrapper = null;
  public edu.syr.npac.webflow.connection.connectionManager _this() {
    return this;
  }
  protected _connectionManagerImplBase(java.lang.String name) {
    super(name);
  }
  public _connectionManagerImplBase() {
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/connection/connectionManager:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("createConnectionObject", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("compute", 0, 1),
      new org.omg.CORBA.portable.MethodPointer("listConnectionObjects", 0, 2),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return edu.syr.npac.webflow.connection._connectionManagerImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(edu.syr.npac.webflow.connection.connectionManager _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      edu.syr.npac.webflow.connection.connectionObject _result = _self.createConnectionObject(arg0);
      edu.syr.npac.webflow.connection.connectionObjectHelper.write(_output, _result);
      return false;
    }
    case 1: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      _self.compute(arg0);
      return false;
    }
    case 2: {
      java.lang.String[] _result = _self.listConnectionObjects();
      edu.syr.npac.webflow.connection.connectionManagerPackage.sequence_of_stringHelper.write(_output, _result);
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
