package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._st_connectionManager
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_st_connectionManager.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionManager {
      ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
        in string arg0
      );
      void compute(
        in string arg0
      );
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
    };
</pre>
</p>
*/
public class _st_connectionManager extends org.omg.CORBA.portable.ObjectImpl implements edu.syr.npac.webflow.connection.connectionManager {
  protected edu.syr.npac.webflow.connection.connectionManager _wrapper = null;
  public edu.syr.npac.webflow.connection.connectionManager _this() {
    return this;
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/connection/connectionManager:1.0"
  };
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::createConnectionObject</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.connection.connectionObject createConnectionObject(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.connection.connectionObject _result;
    while(true) {
      _output = this._request("createConnectionObject", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.connection.connectionObjectHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::compute</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    void compute(
      in string arg0
    );
  </pre>
  </p>
  */
  public void compute(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("compute", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::listConnectionObjects</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
  </pre>
  </p>
  */
  public java.lang.String[] listConnectionObjects() {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    java.lang.String[] _result;
    while(true) {
      _output = this._request("listConnectionObjects", true);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.connection.connectionManagerPackage.sequence_of_stringHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
}
