package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._tie_connectionManager
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_tie_connectionManager.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionManager {
      ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
        in string arg0
      );
      void compute(
        in string arg0
      );
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
    };
</pre>
</p>
*/
public class _tie_connectionManager extends edu.syr.npac.webflow.connection._connectionManagerImplBase {
  private edu.syr.npac.webflow.connection.connectionManagerOperations _delegate;
  public _tie_connectionManager(edu.syr.npac.webflow.connection.connectionManagerOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_connectionManager(edu.syr.npac.webflow.connection.connectionManagerOperations delegate) {
    this._delegate = delegate;
  }
  public edu.syr.npac.webflow.connection.connectionManagerOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::createConnectionObject</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.connection.connectionObject createConnectionObject(
    java.lang.String arg0
  ) {
    return this._delegate.createConnectionObject(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::compute</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    void compute(
      in string arg0
    );
  </pre>
  </p>
  */
  public void compute(
    java.lang.String arg0
  ) {
    this._delegate.compute(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionManager::listConnectionObjects</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionManager"
    ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
  </pre>
  </p>
  */
  public java.lang.String[] listConnectionObjects() {
    return this._delegate.listConnectionObjects(
    );
  }
}
