package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection.connectionObjectHelper
<li> <b>Source File</b> edu/syr/npac/webflow/connection/connectionObjectHelper.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionObject
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionObject:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionObject {
      void addItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      void addItemToTop(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module nextItem();
      ::edu::syr::npac::webflow::module::Module removeItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module insertItemBefore(
        in ::edu::syr::npac::webflow::module::Module arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void setPersistentConnection(
        in boolean arg0
      );
      boolean isPersistentConnection();
      void compute(
      )
      raises(
        ::edu::syr::npac::webflow::exception::webflowException
      );
      void setConnectionInfo(
        in string arg0
      );
      void addNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void removeNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      ::edu::syr::npac::webflow::module::Module getNode(
        in string arg0
      );
      ::java::lang::Object invoke(
        in string arg0,
        in string arg1
      );
    };
</pre>
</p>
*/
abstract public class connectionObjectHelper {
  public static edu.syr.npac.webflow.connection.connectionObject narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static edu.syr.npac.webflow.connection.connectionObject narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof edu.syr.npac.webflow.connection.connectionObject) {
      return (edu.syr.npac.webflow.connection.connectionObject) object;
    }
    if(is_a || object._is_a(id())) {
      edu.syr.npac.webflow.connection._st_connectionObject result = (edu.syr.npac.webflow.connection._st_connectionObject)new edu.syr.npac.webflow.connection._st_connectionObject();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (edu.syr.npac.webflow.connection.connectionObject) result._this();
    }
    return null;
  }
  public static edu.syr.npac.webflow.connection.connectionObject bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static edu.syr.npac.webflow.connection.connectionObject bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static edu.syr.npac.webflow.connection.connectionObject bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static edu.syr.npac.webflow.connection.connectionObject read(org.omg.CORBA.portable.InputStream _input) {
    return edu.syr.npac.webflow.connection.connectionObjectHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, edu.syr.npac.webflow.connection.connectionObject value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, edu.syr.npac.webflow.connection.connectionObject value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static edu.syr.npac.webflow.connection.connectionObject extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "connectionObject");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:edu/syr/npac/webflow/connection/connectionObject:1.0";
  }
}
