package edu.syr.npac.webflow.manager;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.manager._moduleManagerImplBase
<li> <b>Source File</b> edu/syr/npac/webflow/manager/_moduleManagerImplBase.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::manager::moduleManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/manager/moduleManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/manager"
    interface moduleManager {
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
        in ::java::lang::Object arg0
      );
      Object getModuleHandle(
        in string arg0
      );
      ::edu::syr::npac::webflow::module::Module createTransientModule(
        in string arg0
      );
    };
</pre>
</p>
*/
abstract public class _moduleManagerImplBase extends org.omg.CORBA.portable.Skeleton implements edu.syr.npac.webflow.manager.moduleManager {
  protected edu.syr.npac.webflow.manager.moduleManager _wrapper = null;
  public edu.syr.npac.webflow.manager.moduleManager _this() {
    return this;
  }
  protected _moduleManagerImplBase(java.lang.String name) {
    super(name);
  }
  public _moduleManagerImplBase() {
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/manager/moduleManager:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("listModules", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("listMethods", 0, 1),
      new org.omg.CORBA.portable.MethodPointer("listZeroArgumentMethods", 0, 2),
      new org.omg.CORBA.portable.MethodPointer("getModuleHandle", 0, 3),
      new org.omg.CORBA.portable.MethodPointer("createTransientModule", 0, 4),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return edu.syr.npac.webflow.manager._moduleManagerImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(edu.syr.npac.webflow.manager.moduleManager _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      java.lang.String[] _result = _self.listModules();
      edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.write(_output, _result);
      return false;
    }
    case 1: {
      edu.syr.npac.webflow.module.Module arg0;
      arg0 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      java.lang.String[] _result = _self.listMethods(arg0);
      edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.write(_output, _result);
      return false;
    }
    case 2: {
      java.lang.Object arg0;
      arg0 = (java.lang.Object)_input.read_estruct("java.lang.Object");
      java.lang.String[] _result = _self.listZeroArgumentMethods(arg0);
      edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.write(_output, _result);
      return false;
    }
    case 3: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      org.omg.CORBA.Object _result = _self.getModuleHandle(arg0);
      _output.write_Object(_result);
      return false;
    }
    case 4: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      edu.syr.npac.webflow.module.Module _result = _self.createTransientModule(arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, _result);
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
