package edu.syr.npac.webflow.module;

/**
* Interface Module will be implemented by all the 'modules' in the 
* system. All the user code goes into a class that implements the
* module interface
*/

public interface Module extends org.omg.CORBA.Object {

  /**
   * run the module code
   */ 
  public void run();

  /**
   * deallocate all resources allocated by the module. Destroy the module
   */
  public void destroy();
    
}
