/*
 * File: ./PortfolioManager/_PortfolioStub.java
 * From: Portfolio.idl
 * Date: Wed Mar  5 18:51:20 1997
 *   By: idltojava JavaIDL Wed Mar 5 17:02:26 1997
 */

package PortfolioManager;
public class _PortfolioStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements PortfolioManager.Portfolio {

    public _PortfolioStub(org.omg.CORBA.portable.Delegate d) {
          super(d);
    }

    public static final org.omg.CORBA.portable.OperationDescriptor __ops[] = new org.omg.CORBA.portable.OperationDescriptor[7];

    public static org.omg.CORBA.portable.OperationDescriptor[] _get_operations() {
        return __ops;
    }

    static {
           {
           //      Descriptor for ::PortfolioManager::Portfolio::addStock
           int[] _p0 = {
0xe, 0x12 | 0x40000000, 0x2 | 0x40000000, 0x7 | 0x40000000
           };
           Class[] _c0 = {
new PortfolioManager.StockHolder().getClass(), null, null, null
           };
           Class[] _e0 = {

           };
           String[] _exId0 = {

           };
               __ops[0] = new org.omg.CORBA.portable.OperationDescriptor("addStock", _p0, _c0, _exId0, _e0, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::deleteStock
           int[] _p1 = {
             0x12 | 0x40000000
           };
           Class[] _c1 = {
             null
           };
           Class[] _e1 = {

           };
           String[] _exId1 = {

           };
               __ops[1] = new org.omg.CORBA.portable.OperationDescriptor("deleteStock", _p1, _c1, _exId1, _e1, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::getStock
           int[] _p2 = {
0xe, 0x12 | 0x40000000
           };
           Class[] _c2 = {
new PortfolioManager.StockHolder().getClass(), null
           };
           Class[] _e2 = {

           };
           String[] _exId2 = {

           };
               __ops[2] = new org.omg.CORBA.portable.OperationDescriptor("getStock", _p2, _c2, _exId2, _e2, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::buy
           int[] _p3 = {
             0x12 | 0x40000000, 0x2 | 0x40000000
           };
           Class[] _c3 = {
             null, null
           };
           Class[] _e3 = {

           };
           String[] _exId3 = {

           };
               __ops[3] = new org.omg.CORBA.portable.OperationDescriptor("buy", _p3, _c3, _exId3, _e3, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::sell
           int[] _p4 = {
             0x12 | 0x40000000, 0x2 | 0x40000000
           };
           Class[] _c4 = {
             null, null
           };
           Class[] _e4 = {

           };
           String[] _exId4 = {

           };
               __ops[4] = new org.omg.CORBA.portable.OperationDescriptor("sell", _p4, _c4, _exId4, _e4, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::report
           int[] _p5 = {
0x12
           };
           Class[] _c5 = {
null
           };
           Class[] _e5 = {

           };
           String[] _exId5 = {

           };
               __ops[5] = new org.omg.CORBA.portable.OperationDescriptor("report", _p5, _c5, _exId5, _e5, false);
           }


           {
           //      Descriptor for ::PortfolioManager::Portfolio::value
           int[] _p6 = {
0x7
           };
           Class[] _c6 = {
null
           };
           Class[] _e6 = {

           };
           String[] _exId6 = {

           };
               __ops[6] = new org.omg.CORBA.portable.OperationDescriptor("value", _p6, _c6, _exId6, _e6, false);
           }


    }

    private static String _type_ids[] = {
        "IDL:PortfolioManager/Portfolio:1.0"
    };

    public String[] _get_ids() { return _type_ids; }

    //	IDL operations
    //	    Implementation of ::PortfolioManager::Portfolio::addStock
    public PortfolioManager.Stock addStock(String ticker, short number, double price)
 {
           long   _n[] = new long[4];
           java.lang.Object _o[] = new java.lang.Object[4];
           java.lang.Object _e;
           _o[0] = null;
           _o[1] = ticker;
           _n[0] = (number & 0xFFFFL);
           _n[1] = Double.doubleToLongBits(price);
           _e = _invoke(__ops[0], _n, _o);
           return PortfolioManager.StockHelper.narrow((org.omg.CORBA.Object) _o[0]);
    }
    //	    Implementation of ::PortfolioManager::Portfolio::deleteStock
    public void deleteStock(String ticker)
 {
           long   _n[] = new long[1];
           java.lang.Object _o[] = new java.lang.Object[1];
           java.lang.Object _e;
           _o[0] = ticker;
           _e = _invoke(__ops[1], _n, _o);
    }
    //	    Implementation of ::PortfolioManager::Portfolio::getStock
    public PortfolioManager.Stock getStock(String ticker)
 {
           long   _n[] = new long[2];
           java.lang.Object _o[] = new java.lang.Object[2];
           java.lang.Object _e;
           _o[0] = null;
           _o[1] = ticker;
           _e = _invoke(__ops[2], _n, _o);
           return PortfolioManager.StockHelper.narrow((org.omg.CORBA.Object) _o[0]);
    }
    //	    Implementation of ::PortfolioManager::Portfolio::buy
    public void buy(String ticker, short number)
 {
           long   _n[] = new long[2];
           java.lang.Object _o[] = new java.lang.Object[2];
           java.lang.Object _e;
           _o[0] = ticker;
           _n[0] = (number & 0xFFFFL);
           _e = _invoke(__ops[3], _n, _o);
    }
    //	    Implementation of ::PortfolioManager::Portfolio::sell
    public void sell(String ticker, short number)
 {
           long   _n[] = new long[2];
           java.lang.Object _o[] = new java.lang.Object[2];
           java.lang.Object _e;
           _o[0] = ticker;
           _n[0] = (number & 0xFFFFL);
           _e = _invoke(__ops[4], _n, _o);
    }
    //	    Implementation of ::PortfolioManager::Portfolio::report
    public String report()
 {
           long   _n[] = new long[1];
           java.lang.Object _o[] = new java.lang.Object[1];
           java.lang.Object _e;
           _o[0] = new org.omg.CORBA.StringHolder();
           _e = _invoke(__ops[5], _n, _o);
           return (String) _o[0];
    }
    //	    Implementation of ::PortfolioManager::Portfolio::value
    public double value()
 {
           long   _n[] = new long[1];
           java.lang.Object _o[] = new java.lang.Object[1];
           java.lang.Object _e;
           _e = _invoke(__ops[6], _n, _o);
           return Double.longBitsToDouble(_n[0]);
    }

};
