/*
 * File: ./ClientServer/_AccountManagerImplBase.java
 * From: ClientServer.idl
 * Date: Mon Mar 16 11:42:22 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ClientServer;
public abstract class _AccountManagerImplBase extends org.omg.CORBA.DynamicImplementation implements ClientServer.AccountManager {
    // Constructor
    public _AccountManagerImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:ClientServer/AccountManager:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("connect", new java.lang.Integer(0));
      _methods.put("disconnect", new java.lang.Integer(1));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // ClientServer.AccountManager.connect
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userName = _orb().create_any();
              _userName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userName", _userName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _password = _orb().create_any();
              _password.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("password", _password, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _transactionNo = _orb().create_any();
              _transactionNo.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("transactionNo", _transactionNo, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _timein = _orb().create_any();
              _timein.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("timein", _timein, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userName;
              userName = _userName.extract_string();
              String password;
              password = _password.extract_string();
              long transactionNo;
              transactionNo = _transactionNo.extract_longlong();
              String timein;
              timein = _timein.extract_string();
              ClientServer.Transaction ___result;
                            ___result = this.connect(userName, password, transactionNo, timein);
              org.omg.CORBA.Any __result = _orb().create_any();
              ClientServer.TransactionHelper.insert(__result, ___result);
              r.result(__result);
              }
              break;
           case 1: // ClientServer.AccountManager.disconnect
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _transactionNo = _orb().create_any();
              _transactionNo.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("transactionNo", _transactionNo, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long transactionNo;
              transactionNo = _transactionNo.extract_longlong();
                            this.disconnect(transactionNo);
              org.omg.CORBA.Any __return = _orb().create_any();
              __return.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_void));
              r.result(__return);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
