/*
 * File: ./CoordinatorServer/_AcknowledgeStub.java
 * From: CoordinatorServer.idl
 * Date: Fri Mar  6 10:19:13 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package CoordinatorServer;
public class _AcknowledgeStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements CoordinatorServer.Acknowledge {

    public _AcknowledgeStub(org.omg.CORBA.portable.Delegate d) {
          super();
          _set_delegate(d);
    }

    private static final String _type_ids[] = {
        "IDL:CoordinatorServer/Acknowledge:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    //	IDL operations
    //	    Implementation of ::CoordinatorServer::Acknowledge::announceClientInfo
    public boolean announceClientInfo(String userName, String password, long trNo)
 {
           org.omg.CORBA.Request r = _request("announceClientInfo");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _userName = r.add_in_arg();
           _userName.insert_string(userName);
           org.omg.CORBA.Any _password = r.add_in_arg();
           _password.insert_string(password);
           org.omg.CORBA.Any _trNo = r.add_in_arg();
           _trNo.insert_longlong(trNo);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::CoordinatorServer::Acknowledge::numActiveClients
    public int numActiveClients()
 {
           org.omg.CORBA.Request r = _request("numActiveClients");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_long));
           r.invoke();
           int __result;
           __result = r.return_value().extract_long();
           return __result;
   }
    //	    Implementation of ::CoordinatorServer::Acknowledge::numMaxClients
    public int numMaxClients()
 {
           org.omg.CORBA.Request r = _request("numMaxClients");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_long));
           r.invoke();
           int __result;
           __result = r.return_value().extract_long();
           return __result;
   }
    //	    Implementation of ::CoordinatorServer::Acknowledge::checkServer
    public boolean checkServer()
 {
           org.omg.CORBA.Request r = _request("checkServer");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }

};
