/*
 * File: ./ServerDB/_DBServiceImplBase.java
 * From: ServerDB.idl
 * Date: Thu Mar 12 12:41:52 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ServerDB;
public abstract class _DBServiceImplBase extends org.omg.CORBA.DynamicImplementation implements ServerDB.DBService {
    // Constructor
    public _DBServiceImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:ServerDB/DBService:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("open", new java.lang.Integer(0));
      _methods.put("querySaving", new java.lang.Integer(1));
      _methods.put("queryChecking", new java.lang.Integer(2));
      _methods.put("transferSC", new java.lang.Integer(3));
      _methods.put("transferCS", new java.lang.Integer(4));
      _methods.put("close", new java.lang.Integer(5));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // ServerDB.DBService.open
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _username = _orb().create_any();
              _username.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("username", _username, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _password = _orb().create_any();
              _password.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("password", _password, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _trNo = _orb().create_any();
              _trNo.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("trNo", _trNo, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _time = _orb().create_any();
              _time.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("time", _time, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _zone = _orb().create_any();
              _zone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("zone", _zone, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String username;
              username = _username.extract_string();
              String password;
              password = _password.extract_string();
              long trNo;
              trNo = _trNo.extract_longlong();
              String time;
              time = _time.extract_string();
              String zone;
              zone = _zone.extract_string();
              boolean ___result;
                            ___result = this.open(username, password, trNo, time, zone);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 1: // ServerDB.DBService.querySaving
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              String ___result;
                            ___result = this.querySaving();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 2: // ServerDB.DBService.queryChecking
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              String ___result;
                            ___result = this.queryChecking();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 3: // ServerDB.DBService.transferSC
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _trAmount = _orb().create_any();
              _trAmount.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("trAmount", _trAmount, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              float trAmount;
              trAmount = _trAmount.extract_float();
              String ___result;
                            ___result = this.transferSC(trAmount);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 4: // ServerDB.DBService.transferCS
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _trAmount = _orb().create_any();
              _trAmount.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("trAmount", _trAmount, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              float trAmount;
              trAmount = _trAmount.extract_float();
              String ___result;
                            ___result = this.transferCS(trAmount);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 5: // ServerDB.DBService.close
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
                            this.close();
              org.omg.CORBA.Any __return = _orb().create_any();
              __return.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_void));
              r.result(__return);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
