/*
 * File: ./ServerDB/_DBServiceStub.java
 * From: ServerDB.idl
 * Date: Thu Mar 12 12:41:52 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ServerDB;
public class _DBServiceStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements ServerDB.DBService {

    public _DBServiceStub(org.omg.CORBA.portable.Delegate d) {
          super();
          _set_delegate(d);
    }

    private static final String _type_ids[] = {
        "IDL:ServerDB/DBService:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    //	IDL operations
    //	    Implementation of ::ServerDB::DBService::open
    public boolean open(String username, String password, long trNo, String time, String zone)
 {
           org.omg.CORBA.Request r = _request("open");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _username = r.add_in_arg();
           _username.insert_string(username);
           org.omg.CORBA.Any _password = r.add_in_arg();
           _password.insert_string(password);
           org.omg.CORBA.Any _trNo = r.add_in_arg();
           _trNo.insert_longlong(trNo);
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ServerDB::DBService::querySaving
    public String querySaving()
 {
           org.omg.CORBA.Request r = _request("querySaving");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ServerDB::DBService::queryChecking
    public String queryChecking()
 {
           org.omg.CORBA.Request r = _request("queryChecking");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ServerDB::DBService::transferSC
    public String transferSC(float trAmount)
 {
           org.omg.CORBA.Request r = _request("transferSC");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _trAmount = r.add_in_arg();
           _trAmount.insert_float(trAmount);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ServerDB::DBService::transferCS
    public String transferCS(float trAmount)
 {
           org.omg.CORBA.Request r = _request("transferCS");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _trAmount = r.add_in_arg();
           _trAmount.insert_float(trAmount);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ServerDB::DBService::close
    public void close()
 {
           org.omg.CORBA.Request r = _request("close");
           r.invoke();
   }

};
