CREATE OR REPLACE PACKAGE admin_ref AS
    TYPE customertype IS REF CURSOR RETURN customer%ROWTYPE;
    FUNCTION searchUser(uid      IN VARCHAR2,
                        lname    IN VARCHAR2,
                        fname    IN VARCHAR2,
                        phone    IN VARCHAR2) RETURN customertype;
END admin_ref;
/

CREATE OR REPLACE PACKAGE BODY admin_ref AS
    FUNCTION searchUser(uid      IN VARCHAR2,
                        lname    IN VARCHAR2,
                        fname    IN VARCHAR2,
                        phone    IN VARCHAR2) RETURN customertype IS
        sc customertype;
    BEGIN
        OPEN sc FOR SELECT * FROM customer 
                    WHERE (uid IS NULL OR userid = uid) AND
                          (lname IS NULL OR lastname LIKE lname) AND
                          (fname IS NULL OR firstname LIKE fname) AND
                          (phone IS NULL OR phone LIKE phoneno1);
        RETURN sc;
    END;
END admin_ref;
/
