CREATE OR REPLACE PACKAGE admin_ref AS
    TYPE customertype IS REF CURSOR RETURN CUSTOMER%ROWTYPE;
    FUNCTION searchUser(uid      VARCHAR2,
                        lname    VARCHAR2,
                        fname    VARCHAR2,
                        phone    VARCHAR2) RETURN customertype;
END admin_ref;
/

CREATE OR REPLACE PACKAGE BODY admin_ref AS
    FUNCTION searchUser(uid      VARCHAR2,
                        lname    VARCHAR2,
                        fname    VARCHAR2,
                        phone    VARCHAR2) RETURN customertype IS
        rc customertype;
    BEGIN
        OPEN rc FOR SELECT * FROM customer 
                    WHERE (uid IS NULL OR userid = uid) AND
                          (lname IS NULL OR lastname LIKE lname) AND
                          (fname IS NULL OR firstname LIKE fname) AND
                          (phone IS NULL OR phone LIKE phoneno1);
        RETURN rc;
    END;
END admin_ref;
/
