/*
 * File: ./AdministratorICoordinator/_AdministrationImplBase.java
 * From: AdministratorICoordinator.idl
 * Date: Mon Mar 23 23:10:04 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package AdministratorICoordinator;
public abstract class _AdministrationImplBase extends org.omg.CORBA.DynamicImplementation implements AdministratorICoordinator.Administration {
    // Constructor
    public _AdministrationImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:AdministratorICoordinator/Administration:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("addUser", new java.lang.Integer(0));
      _methods.put("deleteUser", new java.lang.Integer(1));
      _methods.put("searchUser", new java.lang.Integer(2));
      _methods.put("getUserData", new java.lang.Integer(3));
      _methods.put("showBalance", new java.lang.Integer(4));
      _methods.put("updateUser", new java.lang.Integer(5));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // AdministratorICoordinator.Administration.addUser
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _lastName = _orb().create_any();
              _lastName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("lastName", _lastName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _firstName = _orb().create_any();
              _firstName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("firstName", _firstName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _address = _orb().create_any();
              _address.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("address", _address, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _hPhone = _orb().create_any();
              _hPhone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("hPhone", _hPhone, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _wPhone = _orb().create_any();
              _wPhone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("wPhone", _wPhone, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _status = _orb().create_any();
              _status.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("status", _status, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _checking = _orb().create_any();
              _checking.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("checking", _checking, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _saving = _orb().create_any();
              _saving.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("saving", _saving, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _timein = _orb().create_any();
              _timein.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("timein", _timein, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String lastName;
              lastName = _lastName.extract_string();
              String firstName;
              firstName = _firstName.extract_string();
              String address;
              address = _address.extract_string();
              String hPhone;
              hPhone = _hPhone.extract_string();
              String wPhone;
              wPhone = _wPhone.extract_string();
              String status;
              status = _status.extract_string();
              float checking;
              checking = _checking.extract_float();
              float saving;
              saving = _saving.extract_float();
              String timein;
              timein = _timein.extract_string();
              boolean ___result;
                            ___result = this.addUser(userid, lastName, firstName, address, hPhone, wPhone, status, checking, saving, timein);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 1: // AdministratorICoordinator.Administration.deleteUser
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _timein = _orb().create_any();
              _timein.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("timein", _timein, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String timein;
              timein = _timein.extract_string();
              boolean ___result;
                            ___result = this.deleteUser(userid, timein);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 2: // AdministratorICoordinator.Administration.searchUser
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _lastName = _orb().create_any();
              _lastName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("lastName", _lastName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _firstName = _orb().create_any();
              _firstName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("firstName", _firstName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _hPhone = _orb().create_any();
              _hPhone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("hPhone", _hPhone, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String lastName;
              lastName = _lastName.extract_string();
              String firstName;
              firstName = _firstName.extract_string();
              String hPhone;
              hPhone = _hPhone.extract_string();
              String ___result;
                            ___result = this.searchUser(userid, lastName, firstName, hPhone);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 3: // AdministratorICoordinator.Administration.getUserData
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String ___result;
                            ___result = this.getUserData(userid);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 4: // AdministratorICoordinator.Administration.showBalance
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String ___result;
                            ___result = this.showBalance(userid);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 5: // AdministratorICoordinator.Administration.updateUser
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userid = _orb().create_any();
              _userid.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userid", _userid, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _lastName = _orb().create_any();
              _lastName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("lastName", _lastName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _firstName = _orb().create_any();
              _firstName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("firstName", _firstName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _address = _orb().create_any();
              _address.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("address", _address, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _hPhone = _orb().create_any();
              _hPhone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("hPhone", _hPhone, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _wPhone = _orb().create_any();
              _wPhone.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("wPhone", _wPhone, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _status = _orb().create_any();
              _status.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("status", _status, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _checking = _orb().create_any();
              _checking.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("checking", _checking, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _saving = _orb().create_any();
              _saving.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("saving", _saving, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _timein = _orb().create_any();
              _timein.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("timein", _timein, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userid;
              userid = _userid.extract_string();
              String lastName;
              lastName = _lastName.extract_string();
              String firstName;
              firstName = _firstName.extract_string();
              String address;
              address = _address.extract_string();
              String hPhone;
              hPhone = _hPhone.extract_string();
              String wPhone;
              wPhone = _wPhone.extract_string();
              String status;
              status = _status.extract_string();
              float checking;
              checking = _checking.extract_float();
              float saving;
              saving = _saving.extract_float();
              String timein;
              timein = _timein.extract_string();
              boolean ___result;
                            ___result = this.updateUser(userid, lastName, firstName, address, hPhone, wPhone, status, checking, saving, timein);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
