import java.io.*;

public class ReturnMessage extends SerializedMessage {
    // Return Message Type:
    //  0: Username/Password verification failed
    //  1: Username/Password verification successful
    //  2: regular returned message from server
    //  3: wrong type of MacMessage type
    //  4: alert message for possible noisy on network or hacker attack
    //  5: Client's reponse to Coordinator
    //  6: Server return Message to Coordinator with available ports
    //  7: Server return the ID to Coordinator
    //  8: Server return the availablity to Coordinator
    //  9: Server return the total number of services (threads) Coordinator
    // 10: Client send time to Server
    //  xxxxx: Coordinator return server hostname and port xxxxx to Client
    
    int              type;
    String           msg;

    public ReturnMessage(int i, String s) {
       type = i;
       msg = s;
    }
}
