package JSci.maths;

/**
* The Vector superclass provides an abstract encapsulation for vectors.
* @version 1.5
* @author Mark Hale
*/
public abstract class Vector extends Tensor {
        /**
        * Constructs a vector.
        */
        public Vector() {}
        /**
        * Returns the norm (magnitude).
        */
        public abstract double norm();
        /**
        * Returns the vector's dimension.
        */
        public abstract int dimension();
}

