package JSci.physics.relativity;

import JSci.maths.*;

/**
* The MinkowskiMetric class provides an object that encapsulates the Minkowski metric.
* @version 1.0
* @author Mark Hale
*/
public final class MinkowskiMetric extends Tensor {
        private double matrix[][];

        /**
        * Constructs the Minkowski metric.
        */
        public MinkowskiMetric() {
                matrix=new double[4][4];
                matrix[0][0]=1.0;
                matrix[1][1]=matrix[2][2]=matrix[3][3]=-1.0;
        }
}

