#!/usr/local/bin/perl -w

print "Enter a temperature (e.g., 32F or 100C):\n";
$input = <STDIN>; chomp( $input );

if ( $input =~ m/^\s*([-+]?\d+(\.\d*)?)\s*(C|F)\s*$/i ) {
  $temp = $1; $type = $3;
  if ( $type =~ m/c/i ) {
    $celsius = $temp;
    $fahrenheit = ( $celsius * 9/5 ) + 32;
  } else {
    $fahrenheit = $temp;
    $celsius = ( $fahrenheit - 32 ) * 5/9;
  }
  printf "%.2f C = %.2f F\n", $celsius, $fahrenheit;
} else {
  print "Expecting a temperature, not \"$input\"\n";
}
