package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util.RandomGenHelper
<li> <b>Source File</b> cis600/util/RandomGenHelper.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
abstract public class RandomGenHelper {
  public static cis600.util.RandomGen narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static cis600.util.RandomGen narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof cis600.util.RandomGen) {
      return (cis600.util.RandomGen) object;
    }
    if(is_a || object._is_a(id())) {
      cis600.util._st_RandomGen result = (cis600.util._st_RandomGen)new cis600.util._st_RandomGen();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (cis600.util.RandomGen) result._this();
    }
    return null;
  }
  public static cis600.util.RandomGen bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static cis600.util.RandomGen bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static cis600.util.RandomGen bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static cis600.util.RandomGen read(org.omg.CORBA.portable.InputStream _input) {
    return cis600.util.RandomGenHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, cis600.util.RandomGen value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, cis600.util.RandomGen value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static cis600.util.RandomGen extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "RandomGen");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:cis600/util/RandomGen:1.0";
  }
}
