package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util.RandomGenHolder
<li> <b>Source File</b> cis600/util/RandomGenHolder.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
final public class RandomGenHolder implements org.omg.CORBA.portable.Streamable {
  public cis600.util.RandomGen value;
  public RandomGenHolder() {
  }
  public RandomGenHolder(cis600.util.RandomGen value) {
    this.value = value;
  }
  public void _read(org.omg.CORBA.portable.InputStream input) {
    value = RandomGenHelper.read(input);
  }
  public void _write(org.omg.CORBA.portable.OutputStream output) {
    RandomGenHelper.write(output, value);
  }
  public org.omg.CORBA.TypeCode _type() {
    return RandomGenHelper.type();
  }
}
