package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util.RandomGenOperations
<li> <b>Source File</b> cis600/util/RandomGenOperations.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
public interface RandomGenOperations {
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextInt</b>.
  <pre>
    long nextInt(
      in long arg0
    );
  </pre>
  </p>
  */
  public int nextInt(
    int arg0
  );
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextIntInRange</b>.
  <pre>
    long nextIntInRange(
      in long arg0,
      in long arg1
    )
    raises(
      ::cis600::util::InvalidOperationException
    );
  </pre>
  </p>
  */
  public int nextIntInRange(
    int arg0,
    int arg1
  ) throws
    cis600.util.InvalidOperationException;
}
