package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util._RandomGenImplBase
<li> <b>Source File</b> cis600/util/_RandomGenImplBase.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
abstract public class _RandomGenImplBase extends org.omg.CORBA.portable.Skeleton implements cis600.util.RandomGen {
  protected cis600.util.RandomGen _wrapper = null;
  public cis600.util.RandomGen _this() {
    return this;
  }
  protected _RandomGenImplBase(java.lang.String name) {
    super(name);
  }
  public _RandomGenImplBase() {
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:cis600/util/RandomGen:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("nextInt", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("nextIntInRange", 0, 1),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return cis600.util._RandomGenImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(cis600.util.RandomGen _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      int arg0;
      arg0 = _input.read_long();
      int _result = _self.nextInt(arg0);
      _output.write_long(_result);
      return false;
    }
    case 1: {
      try {
        int arg0;
        arg0 = _input.read_long();
        int arg1;
        arg1 = _input.read_long();
        int _result = _self.nextIntInRange(arg0,arg1);
        _output.write_long(_result);
      }
      catch(cis600.util.InvalidOperationException _exception) {
        cis600.util.InvalidOperationExceptionHelper.write(_output, _exception);
        return true;
      }
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
