package test.imaging;

import java.awt.*;
/**
 * @author Shrideep Pallickara
 */
public class ImageCanvas extends Canvas {
  public Image image;
  
  /**
   * ImageCanvas constructor comment.
   */
  public ImageCanvas() {
    super();
  }
  public ImageCanvas(Image image) {
    this.image = image;
    resize(image.getWidth(null), image.getHeight(null));
  }

  public void setImage(Image _image) {
    image = _image;
    resize(image.getWidth(null), image.getHeight(null));
    System.out.println("Setting image done ...");
  }

  public void paint(Graphics g) {
    g.drawImage(image, 0, 0, this);
  }
  public void update(Graphics g) {
    paint(g);
  }
}
