/*
 * Context Java Program
 */

import java.applet.*;
import java.awt.*;
import java.net.*;

public class Context extends Applet {
    int x, y;
    Button status, document;
    public void init() {
      setLayout(new GridLayout(x=2, y=1));
      add(status = new Button("ShowStatus"));
      add(document = new Button("ShowDocument"));
      Font font = new Font("TimesRoman", Font.BOLD, 18);
      status.setFont(font);
      document.setFont(font);
    }
    public boolean action(Event ev, Object arg) {
      if ( ev == null ) {
        int t = x;
        x = y; y = t;
        setLayout(new GridLayout(x, y));
        layout();
        return true;
      } else if ( ev.target == status ) {
        getAppletContext().getApplet("receiver").action(null,
          status.getLabel());
        getAppletContext().showStatus("You Click on Show Status!");
        return true;
      } else if ( ev.target == document ) {
        try {
          URL url = new URL(getCodeBase(), "Context.java");
          getAppletContext().showDocument(url);
        } catch (MalformedURLException e);
        return true;
      }
      return false;
    }
}
