package cis600;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class ThreadTracer extends com.sun.java.swing.JApplet implements java.awt.event.ActionListener {
  private com.sun.java.swing.JPanel ivjJAppletContentPane = null;
  private com.sun.java.swing.JButton ivjlistButton = null;
  private com.sun.java.swing.JScrollPane ivjThreadInfoScrollPane = null;
  private com.sun.java.swing.JTextArea ivjthreadInfoTextArea = null;
  /**
   * Method to handle events for the ActionListener interface.
   * @param e java.awt.event.ActionEvent
   */

  public void actionPerformed(java.awt.event.ActionEvent e) {
    if ((e.getSource() == getlistButton()) ) {
      connEtoM1(e);
    }
  }
  /**
   * connEtoM1:  (listButton.action.actionPerformed(java.awt.event.ActionEvent) --> threadInfoTextArea.append(Ljava.lang.String;)V)
   * @param arg1 java.awt.event.ActionEvent
   */

  private void connEtoM1(java.awt.event.ActionEvent arg1) {
    try {
      listThreadsInfo(Thread.currentThread().getThreadGroup());
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * Gets the applet information.
   * @return java.lang.String
   */
  public String getAppletInfo() {
    return "cis600.ThreadTracer created using VisualAge for Java.";
  }

  /**
   * Return the JAppletContentPane property value.
   * @return com.sun.java.swing.JPanel
   */

  private com.sun.java.swing.JPanel getJAppletContentPane() {
    if (ivjJAppletContentPane == null) {
      try {
	ivjJAppletContentPane = new com.sun.java.swing.JPanel();
	ivjJAppletContentPane.setName("JAppletContentPane");
	ivjJAppletContentPane.setLayout(null);
	getJAppletContentPane().add(getThreadInfoScrollPane(), getThreadInfoScrollPane().getName());
	getJAppletContentPane().add(getlistButton(), getlistButton().getName());
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjJAppletContentPane;
  }
  /**
   * Return the listButton property value.
   * @return com.sun.java.swing.JButton
   */

  private com.sun.java.swing.JButton getlistButton() {
    if (ivjlistButton == null) {
      try {
	ivjlistButton = new com.sun.java.swing.JButton();
	ivjlistButton.setName("listButton");
	ivjlistButton.setText("ListInfo");
	ivjlistButton.setBounds(299, 37, 85, 25);
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjlistButton;
  }
  /**
   * Return the ThreadInfoScrollPane property value.
   * @return com.sun.java.swing.JScrollPane
   */

  private com.sun.java.swing.JScrollPane getThreadInfoScrollPane() {
    if (ivjThreadInfoScrollPane == null) {
      try {
	ivjThreadInfoScrollPane = new com.sun.java.swing.JScrollPane();
	ivjThreadInfoScrollPane.setName("ThreadInfoScrollPane");
	ivjThreadInfoScrollPane.setBounds(25, 31, 239, 152);
	getThreadInfoScrollPane().setViewportView(getthreadInfoTextArea());
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjThreadInfoScrollPane;
  }
  /**
   * Return the threadInfoTextArea property value.
   * @return com.sun.java.swing.JTextArea
   */

  private com.sun.java.swing.JTextArea getthreadInfoTextArea() {
    if (ivjthreadInfoTextArea == null) {
      try {
	ivjthreadInfoTextArea = new com.sun.java.swing.JTextArea();
	ivjthreadInfoTextArea.setName("threadInfoTextArea");
	ivjthreadInfoTextArea.setEditable(true);
	ivjthreadInfoTextArea.setDoubleBuffered(true);
	ivjthreadInfoTextArea.setFont(new java.awt.Font("dialog", 1, 12));
	ivjthreadInfoTextArea.setBounds(0, 0, 15, 19);
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjthreadInfoTextArea;
  }
  /**
   * Called whenever the part throws an exception.
   * @param exception java.lang.Throwable
   */
  private void handleException(Throwable exception) {
    
    /* Uncomment the following lines to print uncaught exceptions to stdout */
    // System.out.println("--------- UNCAUGHT EXCEPTION ---------");
    exception.printStackTrace(System.out);
  }
  /**
   * Handle the Applet init method.
   */

  public void init() {
    try {
      setName("ThreadTracer");
      setSize(426, 240);
      setContentPane(getJAppletContentPane());
      loadImage("http://osprey6.npac.syr.edu:8000/rowing.jpg");
      listThreadsInfo(Thread.currentThread().getThreadGroup());
      initConnections();
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  
  private void loadImage(String imageLoc) {
    java.net.URL _urlImage;
    Image _img = null;
    
    try {
      _urlImage = new java.net.URL(imageLoc);
      _img = Toolkit.getDefaultToolkit().getImage(_urlImage);
    } catch (Exception e) {
      try {
	_img = Toolkit.getDefaultToolkit().getImage(imageLoc);
      }  catch (Exception ex) {
	_img=null;
	ex.printStackTrace();
      }
    }
    
    if (_img==null) return;

    /* Use a MediaTracker to wait for the Image to be fully loaded. */
    MediaTracker mt = new MediaTracker(this);
    mt.addImage( _img, 0 );
    System.out.println("Media Tracker waiting to load Image .....");
    try {
      mt.waitForID( 0 );
    } catch(Exception e) {
      return;
    }
  }
  
  private void listThreadsInfo(ThreadGroup group) {
    if (group == null) return;
    Thread[] groupInfo;
    groupInfo   = new Thread[group.activeCount()];
    int iterate = group.enumerate(groupInfo, false);
    
    getthreadInfoTextArea().append("\n" + group + "\n");
    for (int i=0; i < iterate; i++) 
      getthreadInfoTextArea().append("    " + groupInfo[i] +"\n");
    
    listThreadsInfo(group.getParent());
  }
  
  /**
   * Initializes connections
   */

  private void initConnections() {
    getlistButton().addActionListener(this);
  }

  /**
   * main entrypoint - starts the part when it is run as an application
   * @param args java.lang.String[]
   */
  public static void main(java.lang.String[] args) {
    try {
      Frame frame;
      frame = new Frame();
      
      ThreadTracer aThreadTracer;
      Class iiCls = Class.forName("cis600.ThreadTracer");
      ClassLoader iiClsLoader = iiCls.getClassLoader();
      aThreadTracer = (ThreadTracer)java.beans.Beans.instantiate(iiClsLoader,"cis600.ThreadTracer");
      frame.add("Center", aThreadTracer);
      frame.setSize(aThreadTracer.getSize());
      frame.setVisible(true);
    } catch (Throwable exception) {
      System.err.println("Exception occurred in main() of com.sun.java.swing.JApplet");
      exception.printStackTrace(System.out);
    }
  }
}
