package cis600;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class TracerApplet extends Applet implements ActionListener {
  private Button ivjlistInfoButton = null;
  private TextArea ivjthreadInfoTextArea = null;
  
  /**
   * Method to handle events for the ActionListener interface.
   * @param e java.awt.event.ActionEvent
   */
  
  public void actionPerformed(java.awt.event.ActionEvent e) {
    if ((e.getSource() == getlistInfoButton()) ) {
      connEtoM1(e);
    }
  }
  
  /**
   * connEtoM1:  actionPerformed(java.awt.event.ActionEvent) 
   --> threadInfoTextArea.append(Ljava.lang.String;)V)
   * @param arg1 java.awt.event.ActionEvent
   */
  /* WARNING: THIS METHOD WILL BE REGENERATED. */
  private void connEtoM1(java.awt.event.ActionEvent arg1) {
    try {
      listThreadsInfo();
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * Gets the applet information.
   * @return java.lang.String
   */
  public String getAppletInfo() {
    return "cis600.TracerApplet created using VisualAge for Java.";
  }
  /**
   * Return the listInfoButton property value.
   * @return java.awt.Button
   */
  private Button getlistInfoButton() {
    if (ivjlistInfoButton == null) {
      try {
	ivjlistInfoButton = new java.awt.Button();
	ivjlistInfoButton.setName("listInfoButton");
	ivjlistInfoButton.setBounds(316, 55, 56, 23);
	ivjlistInfoButton.setLabel("ListInfo");
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjlistInfoButton;
  }
  /**
   * Return the threadInfoTextArea property value.
   * @return java.awt.TextArea
   */
  private TextArea getthreadInfoTextArea() {
    if (ivjthreadInfoTextArea == null) {
      try {
	ivjthreadInfoTextArea = new java.awt.TextArea();
	ivjthreadInfoTextArea.setName("threadInfoTextArea");
	ivjthreadInfoTextArea.setBounds(26, 21, 221, 122);
      } catch (java.lang.Throwable ivjExc) {
	handleException(ivjExc);
      }
    };
    return ivjthreadInfoTextArea;
  }
  /**
   * Called whenever the part throws an exception.
   * @param exception java.lang.Throwable
   */
  private void handleException(Throwable exception) {
    
    /* Uncomment the following lines to print uncaught exceptions to stdout */
    // System.out.println("--------- UNCAUGHT EXCEPTION ---------");
    // exception.printStackTrace(System.out);
  }
  
  
  private void listThreadsInfo() {
    Thread[] groupInfo;
    ThreadGroup group = Thread.currentThread().getThreadGroup();
    
    groupInfo   = new Thread[group.activeCount()];
    int iterate = group.enumerate(groupInfo, false);
    getthreadInfoTextArea().append(group + "\n");
    for (int i=0; i < iterate; i++) 
      getthreadInfoTextArea().append("    " + groupInfo[i] +"\n");
    listParentInfo(group);
  }
  
  private void listParentInfo(ThreadGroup _group) {
    Thread[] groupInfo = 
      new Thread[_group.getParent().activeCount()];
    int iterate = _group.getParent().enumerate(groupInfo, false);
    
    getthreadInfoTextArea().append(_group.getParent() + "\n");
    for (int i=0; i < iterate; i++) 
      getthreadInfoTextArea().append("    " + groupInfo[i] +"\n");   
  }
  /**
   * Handle the Applet init method.
   */
  public void init() {
    super.init();
    try {
      setName("TracerApplet");
      setLayout(null);
      setSize(426, 240);
      add(getthreadInfoTextArea(), 
	  getthreadInfoTextArea().getName());
      add(getlistInfoButton(), getlistInfoButton().getName());
      initConnections();
      listThreadsInfo();
    } catch (java.lang.Throwable ivjExc) {
      handleException(ivjExc);
    }
  }
  /**
   * Initializes connections
   */
  
  private void initConnections() {
    getlistInfoButton().addActionListener(this);
  }
  
  /**
   * main entrypoint - starts the part when it is run as an application
   * @param args java.lang.String[]
   */
  public static void main(java.lang.String[] args) {
    try {
      Frame frame;
      try {
	Class aFrameClass = Class.forName("com.ibm.uvm.abt.edit.TestFrame");
	frame = (Frame)aFrameClass.newInstance();
      } catch (java.lang.Throwable ivjExc) {
	frame = new Frame();
      }
      TracerApplet aTracerApplet;
      Class iiCls = Class.forName("cis600.TracerApplet");
      ClassLoader iiClsLoader = iiCls.getClassLoader();
      aTracerApplet = (TracerApplet)java.beans.Beans.instantiate(iiClsLoader,"cis600.TracerApplet");
      frame.add("Center", aTracerApplet);
      frame.setSize(aTracerApplet.getSize());
      frame.setVisible(true);
    } catch (Throwable exception) {
      System.err.println("Exception occurred in main() of java.applet.Applet");
      exception.printStackTrace(System.out);
    }
  }
}
