/*********************************************************
 * Experiment of using Gaurded Suspension policy         *
 * Author : Kemal, Mahesh, Meryem, Mohammed and Shrideep * 
 * Date   : October 14, 1998				 *
 *        CIS 600   Concurrent Java			 *
 *********************************************************/
  
class Runway {
  public static final int LANDING = 1;
  public static final int TAKEOFF = -1;
  public static final int MAX_CAPACITY = 3;
  public static final int Counter= 1;
  private int Number_Of_Airplane = 0; 

public  synchronized  void ArriveRunway(String name) {
     while( Number_Of_Airplane >= MAX_CAPACITY){ 
      try { 
          System.out.println(" Runways are Full "+ name + " has to wait");
          wait(); } 
           catch (InterruptedException e) {}
        }  
        System.out.println(name + " On the runway");
        Number_Of_Airplane += Counter;
  }
public synchronized void ExitRunway(String name) {

     Number_Of_Airplane -= Counter;
     System.out.println(name +"  left, notify an airplane");
     notify();      
  }
}

class Airplane extends Thread {
      private String name;
      private Runway runway;
      private int direction;
  Airplane(String nam, Runway runw, int dir) 
  {
      name = nam; 
      runway = runw; 
      direction = dir;
    if (direction ==1 )
          setDaemon(true);
     else 
         setDaemon(false);
      start();
}
  public void run() {
    System.out.println(name + " Ready To " +
                            (direction==Runway.LANDING? "LANDING" : "TAKEOFF"));
    runway.ArriveRunway(name);
       try {
        sleep(10);
      } catch (InterruptedException e) {}
    runway.ExitRunway(name);
  }
}
public class RunwayTest {
   public static void main(String [] args) {
    Runway runway = new Runway();
    new Airplane("Airplane 1", runway, Runway.LANDING);
    new Airplane("Airplane 2",  runway, Runway.TAKEOFF);
    new Airplane("Airplane 3",  runway, Runway.LANDING);
    new Airplane("Airplane 4",  runway, Runway.TAKEOFF);
    new Airplane("Airplane 5",  runway, Runway.LANDING);
    new Airplane("Airplane 6",  runway, Runway.TAKEOFF);
    new Airplane("Airplane 7",  runway, Runway.LANDING);
    new Airplane("Airplane 8",  runway, Runway.TAKEOFF);
    new Airplane("Airplane 9",  runway, Runway.LANDING);
    new Airplane("Airplane 10",  runway, Runway.TAKEOFF);
 }
}
