/****************************************************************
 * Experiment to explore the effect of sleep method on the lock *
 * Author : Kemal, Mahesh, Meryem, Mohammed and Shrideep        * 
 * Date   : October 28, 1998				        *
 *        CIS 600   Concurrent Java		     	        *
 ****************************************************************/
  
class Runways {

  public static final int LANDING = 1;
  public static final int TAKEOFF = -1;
  public static final int Counter= 1;
  private int Number_Of_Airplane = 0; 

public synchronized  void ArriveRunway(String name) {

      try { 

          System.out.println("The "+ name + " is Sleeping in the Runway");
          Number_Of_Airplane += Counter;
          Thread.sleep(5000);
} 
           catch (InterruptedException e) {}
        System.out.println(name + " is Running On the runway");
  }

public int getNum()
 { return Number_Of_Airplane; }

}

class Airplanes extends Thread {
  private String name;
  private Runways runways;
  private int direction;

  Airplanes(String nam, Runways runw, int dir) 

  {
      name = nam; 
      runways = runw; 
      direction = dir;
      start();
  }

  public void run() {

    while (runways.getNum()<=10) {
    System.out.println(name + " Ready To " +
                     (direction==Runways.LANDING? "LANDING" : "TAKEOFF"));
    runways.ArriveRunway(name);
   }
  }
}
public class RunSleep 
            {
   public static void main(String [] args) {

    Runways runways = new Runways();

    new Airplanes("Airplane 1", runways, Runways.LANDING);
    new Airplanes("Airplane 2", runways, Runways.TAKEOFF);
    new Airplanes("Airplane 3", runways, Runways.LANDING);
    new Airplanes("Airplane 4", runways, Runways.TAKEOFF);
    new Airplanes("Airplane 5", runways, Runways.LANDING);
 } }

