
package demos.rmi;

import java.rmi.*;
import java.rmi.server.*;
import java.net.*;

public class RMIClientControlImpl extends UnicastRemoteObject
implements jdce.client.RMIClientProxy {
  private RMIChatUser thisClient; 
  
  RMIClientControlImpl(Object client) throws java.rmi.RemoteException
  { 
    super(); 
    thisClient = (RMIChatUser)client; 
    System.out.println("Client Control Object Created as client" 
+ thisClient.clientNumber); 
  } 
  
  public boolean dataReceive(String Message) throws java.rmi.RemoteException{
    return thisClient.dataReceive(Message);
  }
  
  public boolean messageReceive(jdce.util.message.jdceMessage Message) throws
  java.rmi.RemoteException {
    return thisClient.messageReceive(Message);
  }
  
  public boolean clientEvent(jdce.util.event.jdceEvent evt) 
       throws java.rmi.RemoteException{
	 thisClient.listMembers();
	 System.out.println(evt.typeToString());
	 return true;
  }

}
