package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection.connectionManagerHelper
<li> <b>Source File</b> edu/syr/npac/webflow/connection/connectionManagerHelper.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionManager {
      ::edu::syr::npac::webflow::connection::connectionObject createConnectionObject(
        in string arg0
      );
      void compute(
        in string arg0
      );
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::connection::connectionManager::sequence_of_string listConnectionObjects();
    };
</pre>
</p>
*/
abstract public class connectionManagerHelper {
  public static edu.syr.npac.webflow.connection.connectionManager narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static edu.syr.npac.webflow.connection.connectionManager narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof edu.syr.npac.webflow.connection.connectionManager) {
      return (edu.syr.npac.webflow.connection.connectionManager) object;
    }
    if(is_a || object._is_a(id())) {
      edu.syr.npac.webflow.connection._st_connectionManager result = (edu.syr.npac.webflow.connection._st_connectionManager)new edu.syr.npac.webflow.connection._st_connectionManager();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (edu.syr.npac.webflow.connection.connectionManager) result._this();
    }
    return null;
  }
  public static edu.syr.npac.webflow.connection.connectionManager bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static edu.syr.npac.webflow.connection.connectionManager bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static edu.syr.npac.webflow.connection.connectionManager bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static edu.syr.npac.webflow.connection.connectionManager read(org.omg.CORBA.portable.InputStream _input) {
    return edu.syr.npac.webflow.connection.connectionManagerHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, edu.syr.npac.webflow.connection.connectionManager value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, edu.syr.npac.webflow.connection.connectionManager value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static edu.syr.npac.webflow.connection.connectionManager extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "connectionManager");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:edu/syr/npac/webflow/connection/connectionManager:1.0";
  }
}
