package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection.connectionObjectHolder
<li> <b>Source File</b> edu/syr/npac/webflow/connection/connectionObjectHolder.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionObject
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionObject:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionObject {
      void addItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      void addItemToTop(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module nextItem();
      ::edu::syr::npac::webflow::module::Module removeItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module insertItemBefore(
        in ::edu::syr::npac::webflow::module::Module arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void setPersistentConnection(
        in boolean arg0
      );
      boolean isPersistentConnection();
      void compute(
      )
      raises(
        ::edu::syr::npac::webflow::exception::webflowException
      );
      void setConnectionInfo(
        in string arg0
      );
      void addNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void removeNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      ::edu::syr::npac::webflow::module::Module getNode(
        in string arg0
      );
      ::java::lang::Object invoke(
        in string arg0,
        in string arg1
      );
    };
</pre>
</p>
*/
final public class connectionObjectHolder implements org.omg.CORBA.portable.Streamable {
  public edu.syr.npac.webflow.connection.connectionObject value;
  public connectionObjectHolder() {
  }
  public connectionObjectHolder(edu.syr.npac.webflow.connection.connectionObject value) {
    this.value = value;
  }
  public void _read(org.omg.CORBA.portable.InputStream input) {
    value = edu.syr.npac.webflow.connection.connectionObjectHelper.read(input);
  }
  public void _write(org.omg.CORBA.portable.OutputStream output) {
    edu.syr.npac.webflow.connection.connectionObjectHelper.write(output, value);
  }
  public org.omg.CORBA.TypeCode _type() {
    return edu.syr.npac.webflow.connection.connectionObjectHelper.type();
  }
}
