package edu.syr.npac.webflow.manager;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.manager.moduleManagerHelper
<li> <b>Source File</b> edu/syr/npac/webflow/manager/moduleManagerHelper.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::manager::moduleManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/manager/moduleManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/manager"
    interface moduleManager {
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
        in ::java::lang::Object arg0
      );
      Object getModuleHandle(
        in string arg0
      );
      ::edu::syr::npac::webflow::module::Module createTransientModule(
        in string arg0
      );
    };
</pre>
</p>
*/
abstract public class moduleManagerHelper {
  public static edu.syr.npac.webflow.manager.moduleManager narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static edu.syr.npac.webflow.manager.moduleManager narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof edu.syr.npac.webflow.manager.moduleManager) {
      return (edu.syr.npac.webflow.manager.moduleManager) object;
    }
    if(is_a || object._is_a(id())) {
      edu.syr.npac.webflow.manager._st_moduleManager result = (edu.syr.npac.webflow.manager._st_moduleManager)new edu.syr.npac.webflow.manager._st_moduleManager();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (edu.syr.npac.webflow.manager.moduleManager) result._this();
    }
    return null;
  }
  public static edu.syr.npac.webflow.manager.moduleManager bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static edu.syr.npac.webflow.manager.moduleManager bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static edu.syr.npac.webflow.manager.moduleManager bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static edu.syr.npac.webflow.manager.moduleManager read(org.omg.CORBA.portable.InputStream _input) {
    return edu.syr.npac.webflow.manager.moduleManagerHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, edu.syr.npac.webflow.manager.moduleManager value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, edu.syr.npac.webflow.manager.moduleManager value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static edu.syr.npac.webflow.manager.moduleManager extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "moduleManager");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:edu/syr/npac/webflow/manager/moduleManager:1.0";
  }
}
