package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging._st_ImageInputModule
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/_st_ImageInputModule.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageInputModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageInputModule : ::edu::syr::npac::webflow::module::Module {
      void setImageLocation(
        in string arg0
      );
      long getWidth();
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
public class _st_ImageInputModule extends edu.syr.npac.webflow.module._st_Module implements edu.syr.npac.webflow.module.imaging.ImageInputModule {
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0",
    "IDL:edu/syr/npac/webflow/module/Module:1.0"
  };
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::setImageLocation</b>.
  <pre>
    void setImageLocation(
      in string arg0
    );
  </pre>
  </p>
  */
  public void setImageLocation(
    java.lang.String arg0
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("setImageLocation", true);
      _output.write_string(arg0);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      setImageLocation(
        arg0
      );
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getWidth</b>.
  <pre>
    long getWidth();
  </pre>
  </p>
  */
  public int getWidth() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getWidth", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getWidth();
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getHeight</b>.
  <pre>
    long getHeight();
  </pre>
  </p>
  */
  public int getHeight() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getHeight", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getHeight();
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getPixels</b>.
  <pre>
    ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
  </pre>
  </p>
  */
  public int[] getPixels() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getPixels", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int[] _result;
      _result = edu.syr.npac.webflow.module.imaging.ImageInputModulePackage.sequence_of_longHelper.read(_input);
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getPixels();
    }
  }
}
