package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging._tie_ImageModule
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/_tie_ImageModule.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageModule : ::edu::syr::npac::webflow::module::Module {
      void setWidth(
        in long arg0
      );
      long getWidth();
      void setHeight(
        in long arg0
      );
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      void setPixels(
        in ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long arg0
      );
      ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
public class _tie_ImageModule extends edu.syr.npac.webflow.module.imaging._ImageModuleImplBase {
  private edu.syr.npac.webflow.module.imaging.ImageModuleOperations _delegate;
  public _tie_ImageModule(edu.syr.npac.webflow.module.imaging.ImageModuleOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_ImageModule(edu.syr.npac.webflow.module.imaging.ImageModuleOperations delegate) {
    this._delegate = delegate;
  }
  public edu.syr.npac.webflow.module.imaging.ImageModuleOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setWidth</b>.
  <pre>
    void setWidth(
      in long arg0
    );
  </pre>
  </p>
  */
  public void setWidth(
    int arg0
  ) {
    this._delegate.setWidth(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getWidth</b>.
  <pre>
    long getWidth();
  </pre>
  </p>
  */
  public int getWidth() {
    return this._delegate.getWidth(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setHeight</b>.
  <pre>
    void setHeight(
      in long arg0
    );
  </pre>
  </p>
  */
  public void setHeight(
    int arg0
  ) {
    this._delegate.setHeight(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getHeight</b>.
  <pre>
    long getHeight();
  </pre>
  </p>
  */
  public int getHeight() {
    return this._delegate.getHeight(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setPixels</b>.
  <pre>
    void setPixels(
      in ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long arg0
    );
  </pre>
  </p>
  */
  public void setPixels(
    int[] arg0
  ) {
    this._delegate.setPixels(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getPixels</b>.
  <pre>
    ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long getPixels();
  </pre>
  </p>
  */
  public int[] getPixels() {
    return this._delegate.getPixels(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::Module::run</b>.
  <pre>
    void run();
  </pre>
  </p>
  */
  public void run() {
    this._delegate.run(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::Module::destroy</b>.
  <pre>
    void destroy();
  </pre>
  </p>
  */
  public void destroy() {
    this._delegate.destroy(
    );
  }
}
