/*
 *  File:  CheckboxDemo.java
 *
 *  Create some checkboxes
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Color;
import java.awt.Checkbox;
import java.awt.Panel;

public class CheckboxDemo extends java.applet.Applet {

  private Checkbox[] box = new Checkbox[5];

  public void init() {
    setBackground( Color.white );
    Color lightBlue = new Color( 0xB0, 0xE0, 0xE6 );
    Color  navyBlue = new Color( 0x19, 0x19, 0x70 );

    // Instantiate some checkboxes:
    box[0] = new Checkbox( "Shoes" );
    box[1] = new Checkbox( "Socks" );
    box[2] = new Checkbox( "Pants" );
    box[3] = new Checkbox( "Shirt" );
    // Check the next box by default:
    boolean checked = true;
    box[4] = new Checkbox( "Underwear", checked );
    
    // Add checkboxes to a panel and register with applet:
    Panel checkboxPanel = new Panel();
    checkboxPanel.setBackground( lightBlue );
    for ( int i = 0; i < box.length; i++ ) {
      box[i].setForeground(  navyBlue );
      box[i].setBackground( lightBlue );
      checkboxPanel.add( box[i] );
    }
    
    add( checkboxPanel );
    
  }

}
