/*
 *  File:  ChoiceDemo.java
 *
 *  Choosing items from a drop-down list
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.Color;
import java.awt.Label;
import java.awt.Choice;

public class ChoiceDemo extends java.applet.Applet {

  private Label label1, label2;
  private Choice directoryList, formatList;

  public void init() {
    setBackground( Color.white );

    label1 = new Label( "Directory:  ", Label.RIGHT );
    
    directoryList = new Choice();
    directoryList.addItem( "HTML"       );
    directoryList.addItem( "JavaScript" );
    directoryList.addItem( "CGI"        );
    directoryList.addItem( "Java"       );
    directoryList.addItem( "JDBC"       );
    directoryList.addItem( "VRML"       );
    // Select "JavaScript" as the default menu choice:
    directoryList.select(1);
    directoryList.setBackground( Color.white );

    label2 = new Label( "   Format:  ", Label.RIGHT );
    
    formatList = new Choice();
    formatList.addItem( ".zip"    );
    formatList.addItem( ".tar.Z"  );
    formatList.addItem( ".tar.gz" );
    formatList.addItem( ".sit"    );
    // Select ".tar.gz" as the default menu choice:
    formatList.select(2);
    formatList.setBackground( Color.white );
    
    add( label1 ); add( directoryList );
    add( label2 ); add( formatList );
  }
  
}
