/*
 *  File:  TextFieldDemo.java
 *
 *  Create an editable text field (i.e., a one-line text area)
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Color;

public class TextFieldDemo extends Applet {

  private Label label1, label2;
  private TextField username, password;

  public void init() {
    
    setBackground( Color.white );
    
    label1 = new Label( "Username:  ", Label.RIGHT );
    
    username = new TextField( 20 );
    
    label2 = new Label( "Password:  ", Label.RIGHT );
    
    password = new TextField( 20 );
    password.setEchoChar( '*' );
    
    add( label1 ); add( username );
    add( label2 ); add( password );
  }

}
