/*
 *  File:  OctagonTest.java
 *
 *  Drawing octagons
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Polygon;
import java.awt.Color;

public class OctagonTest extends Applet {

   // create references to two polygons:
   private Polygon p1, p2;
   
   public void init() {
   
      // instantiate a polygon object:
      p1 = new Polygon();

      // add points to make a square:
      p1.addPoint(  25,  25 );
      p1.addPoint( 175,  25 );
      p1.addPoint( 175, 175 );
      p1.addPoint(  25, 175 );

      // instantiate a polygon object:
      p2 = new Polygon();

      // add points to make an octagon:
      p2.addPoint(  75,  25 );
      p2.addPoint( 125,  25 );
      p2.addPoint( 175,  75 );
      p2.addPoint( 175, 125 );
      p2.addPoint( 125, 175 );
      p2.addPoint(  75, 175 );
      p2.addPoint(  25, 125 );
      p2.addPoint(  25,  75 );

   }
   
   public void paint( Graphics g ) {

      // draw a square:
      g.setColor( Color.yellow );
      g.drawPolygon( p1 );

      // draw an octagon:
      g.setColor( Color.red );
      g.drawPolygon( p2 );

   }
   
}
