/*
 *  File:  Test3DRect.java
 *
 *  Draw some 3-D rectangles
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class Test3DRect extends Applet {

   public void paint( Graphics g ) {
   
      boolean raised;  // a local variable
      
      g.setColor( Color.yellow );

      // draw a raised 3D rectangle at point ( 10, 10 ):
      g.draw3DRect( 10, 10, 100, 100, raised = true );

      // draw a sunken 3D rectangle at point ( 130, 10 ):
      g.draw3DRect( 130, 10, 100, 100, raised = false );

      // draw a filled, raised 3D rectangle at point ( 10, 120 ):
      g.fill3DRect( 10, 120, 100, 100, raised = true );

      // draw a filled, sunken 3D rectangle at point ( 130, 120 ):
      g.fill3DRect( 130, 120, 100, 100, raised = false );
      
   }
   
}
