/*
 *  File:  DrawablePolygonTest3.java
 *
 *  Draw some regular polygons
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Point;

public class DrawablePolygonTest3 extends Applet {

   // create a reference to a polygon:
   private DrawablePolygon polygon;
   
   private int r;
   private int border;
   
   public void init() {
   
      // radius of regular polygons:
      r = 50;
      // space between polygons:
      border = 20;
    
   }
   
   public void paint( Graphics g ) {

      // anchor point of each polygon:
      int x, y;

      // initial degree:
      int n = 3;

      // draw a 3x3 grid of regular polygons:
      y = -r;
      for ( int i = 0; i < 3; i++ ) {
         x = -r; y += border + 2*r;
         for ( int j = 0; j < 3; j++ ) {
            x += border + 2*r;
            polygon = new DrawablePolygon( x, y, r, n++ );
            polygon.fill( g );
         }
      }

   }
   
}
