/*
 *  File:  Rhombus.java
 *
 *  Rhombus class
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

// A rhombus is a parallelogram with equal sides:
public class Rhombus extends Parallelogram {

   // Rhombus constructor #1:
   public Rhombus( int x, int y, int size, double alpha  ) {
 
      // invoke a constructor of the superclass:
      super( x, y, size, size, alpha );
 
   }

   // Rhombus constructor #2:
   public Rhombus( int x, int y, int size, double alpha, double theta ) {
 
      // invoke a constructor of the superclass:
      super( x, y, size, size, alpha, theta );
 
   }

}
