/*
 *  File:  ColorBoxes.java
 *
 *  Drawing simple shapes, especially rectangles and ovals
 *
 *  Copyright:  Northeast Parallel Architectures Center
 */

import java.awt.Color;
import java.awt.Graphics;

public class ColorBoxes extends java.applet.Applet {

  public void paint(Graphics g) {
    int rval, gval, bval;

    // getSize() method is new in Java 1.1:
    for (int j = 30; j < (getSize().height - 25); j += 30) {
      for (int i = 5; i < (getSize().width - 25); i += 30) {
        rval = (int)Math.floor(Math.random() * 256);
        gval = (int)Math.floor(Math.random() * 256);
        bval = (int)Math.floor(Math.random() * 256);
        
        g.setColor(new Color(rval,gval,bval));
        g.fillRect(i,j,25,25);
        g.setColor(Color.black);
        g.drawRect(i,j,25,25);
      }
    }
  }
  
}
