
# This makefile delivers two beans 
# in a single JAR file.

CLASSFILES= \
	sunw/demo/hotspots/Coordinates.class \
	sunw/demo/hotspots/Dimensions.class \
	sunw/demo/hotspots/HotSpot.class \
	sunw/demo/hotspots/HotSpotMgr.class \
	sunw/demo/hotspots/ShapeMgrBeanInfo.class \
	sunw/demo/hotspots/RectangleShape.class \
	sunw/demo/hotspots/LineShape.class \
	sunw/demo/hotspots/OvalShape.class \
	sunw/demo/hotspots/Shape.class\
        sunw/demo/hotspots/ShapeNameEditor.class\
        sunw/demo/hotspots/ShapeColorEditor.class\
        sunw/demo/hotspots/FocusColorEditor.class\
        sunw/demo/hotspots/ShapeThicknessEditor.class\
        sunw/demo/hotspots/ShapeMgr.class


DATAFILES= \
	sunw/demo/hotspots/faces.gif

JARFILE= /usr/npac/BDK/jars/HotSpots.jar

all: $(JARFILE)

# Create a JAR file with a suitable manifest.

$(JARFILE): $(CLASSFILES) $(DATAFILES)
	echo "Name: sunw/demo/hotspots/ShapeMgr.class" >> manifest.tmp
	echo "Java-Bean: True" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/Dimensions.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/HotSpot.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/HotSpotMgr.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/ShapeMgrBeanInfo.class" >>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/RectangleShape.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/LineShape.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/OvalShape.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/Shape.class" >> manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/ShapeNameEditor.class" >>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/ShapeThicknessEditor.class" >>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name:sunw/demo/hotspots/ShapeColorEditor.class">>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name:sunw/demo/hotspots/FocusColorEditor.class">>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	echo "Name: sunw/demo/hotspots/Coordinates.class" >>manifest.tmp
	echo "Java-Bean: False" >> manifest.tmp
	echo "" >> manifest.tmp
	jar cfm $(JARFILE) manifest.tmp sunw/demo/hotspots/*.class $(DATAFILES)
	@/bin/rm manifest.tmp

# Rule for compiling a normal .java file
%.class: %.java
	export CLASSPATH; CLASSPATH=. ; \
	javac $<

clean:
	/bin/rm -f sunw/demo/hotspots/*.class
	/bin/rm -f $(JARFILE)
