package sunw.demo.hotspots;

import java.beans.*;

public class ShapeMgrBeanInfo extends SimpleBeanInfo {
	
  public java.awt.Image getIcon(int iconType) {
    if (iconType == BeanInfo.ICON_COLOR_16x16) {
      java.awt.Image img = loadImage("faces.gif");
      return img;
    }
    return null;
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try {
      PropertyDescriptor pd = new PropertyDescriptor("shapeName",
                                                     ShapeMgr.class);
      PropertyDescriptor pd1 = new PropertyDescriptor("shapeColor", 
                                                      ShapeMgr.class);
      pd.setPropertyEditorClass(ShapeNameEditor.class);
      pd1.setPropertyEditorClass(ShapeColorEditor.class);
      PropertyDescriptor pda[] = { pd, pd1 };
      return pda;
    }
    catch (Exception ex) {
      return null;
    }
  }
}
