package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._connectionObjectImplBase
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_connectionObjectImplBase.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionObject
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionObject:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionObject {
      void addItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      void addItemToTop(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module nextItem();
      ::edu::syr::npac::webflow::module::Module removeItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module insertItemBefore(
        in ::edu::syr::npac::webflow::module::Module arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void setPersistentConnection(
        in boolean arg0
      );
      boolean isPersistentConnection();
      void compute(
      )
      raises(
        ::edu::syr::npac::webflow::exception::webflowException
      );
      void setConnectionInfo(
        in string arg0
      );
      void addNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void removeNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      ::edu::syr::npac::webflow::module::Module getNode(
        in string arg0
      );
      ::java::lang::Object invoke(
        in string arg0,
        in string arg1
      );
    };
</pre>
</p>
*/
abstract public class _connectionObjectImplBase extends org.omg.CORBA.portable.Skeleton implements edu.syr.npac.webflow.connection.connectionObject {
  protected edu.syr.npac.webflow.connection.connectionObject _wrapper = null;
  public edu.syr.npac.webflow.connection.connectionObject _this() {
    return this;
  }
  protected _connectionObjectImplBase(java.lang.String name) {
    super(name);
  }
  public _connectionObjectImplBase() {
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/connection/connectionObject:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("addItem", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("addItemToTop", 0, 1),
      new org.omg.CORBA.portable.MethodPointer("nextItem", 0, 2),
      new org.omg.CORBA.portable.MethodPointer("removeItem", 0, 3),
      new org.omg.CORBA.portable.MethodPointer("insertItemBefore", 0, 4),
      new org.omg.CORBA.portable.MethodPointer("setPersistentConnection", 0, 5),
      new org.omg.CORBA.portable.MethodPointer("isPersistentConnection", 0, 6),
      new org.omg.CORBA.portable.MethodPointer("compute", 0, 7),
      new org.omg.CORBA.portable.MethodPointer("setConnectionInfo", 0, 8),
      new org.omg.CORBA.portable.MethodPointer("addNode", 0, 9),
      new org.omg.CORBA.portable.MethodPointer("removeNode", 0, 10),
      new org.omg.CORBA.portable.MethodPointer("getNode", 0, 11),
      new org.omg.CORBA.portable.MethodPointer("invoke", 0, 12),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return edu.syr.npac.webflow.connection._connectionObjectImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(edu.syr.npac.webflow.connection.connectionObject _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      edu.syr.npac.webflow.module.Module arg0;
      arg0 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      _self.addItem(arg0);
      return false;
    }
    case 1: {
      edu.syr.npac.webflow.module.Module arg0;
      arg0 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      _self.addItemToTop(arg0);
      return false;
    }
    case 2: {
      edu.syr.npac.webflow.module.Module _result = _self.nextItem();
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, _result);
      return false;
    }
    case 3: {
      edu.syr.npac.webflow.module.Module arg0;
      arg0 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      edu.syr.npac.webflow.module.Module _result = _self.removeItem(arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, _result);
      return false;
    }
    case 4: {
      edu.syr.npac.webflow.module.Module arg0;
      arg0 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      edu.syr.npac.webflow.module.Module arg1;
      arg1 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      edu.syr.npac.webflow.module.Module _result = _self.insertItemBefore(arg0,arg1);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, _result);
      return false;
    }
    case 5: {
      boolean arg0;
      arg0 = _input.read_boolean();
      _self.setPersistentConnection(arg0);
      return false;
    }
    case 6: {
      boolean _result = _self.isPersistentConnection();
      _output.write_boolean(_result);
      return false;
    }
    case 7: {
      try {
        _self.compute();
      }
      catch(edu.syr.npac.webflow.exception.webflowException _exception) {
        edu.syr.npac.webflow.exception.webflowExceptionHelper.write(_output, _exception);
        return true;
      }
      return false;
    }
    case 8: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      _self.setConnectionInfo(arg0);
      return false;
    }
    case 9: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      edu.syr.npac.webflow.module.Module arg1;
      arg1 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      _self.addNode(arg0,arg1);
      return false;
    }
    case 10: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      edu.syr.npac.webflow.module.Module arg1;
      arg1 = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      _self.removeNode(arg0,arg1);
      return false;
    }
    case 11: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      edu.syr.npac.webflow.module.Module _result = _self.getNode(arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, _result);
      return false;
    }
    case 12: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      java.lang.String arg1;
      arg1 = _input.read_string();
      java.lang.Object _result = _self.invoke(arg0,arg1);
      _output.write_estruct(_result, "java.lang.Object");
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
