package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._example_connectionObject
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_example_connectionObject.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionObject
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionObject:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionObject {
      void addItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      void addItemToTop(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module nextItem();
      ::edu::syr::npac::webflow::module::Module removeItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module insertItemBefore(
        in ::edu::syr::npac::webflow::module::Module arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void setPersistentConnection(
        in boolean arg0
      );
      boolean isPersistentConnection();
      void compute(
      )
      raises(
        ::edu::syr::npac::webflow::exception::webflowException
      );
      void setConnectionInfo(
        in string arg0
      );
      void addNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void removeNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      ::edu::syr::npac::webflow::module::Module getNode(
        in string arg0
      );
      ::java::lang::Object invoke(
        in string arg0,
        in string arg1
      );
    };
</pre>
</p>
*/
public class _example_connectionObject extends edu.syr.npac.webflow.connection._connectionObjectImplBase {
  /** Construct a persistently named object. */
  public _example_connectionObject(java.lang.String name) {
    super(name);
  }
  /** Construct a transient object. */
  public _example_connectionObject() {
    super();
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addItem(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public void addItem(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addItemToTop</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addItemToTop(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public void addItemToTop(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::nextItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module nextItem();
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module nextItem() {
    // IMPLEMENT: Operation
    return null;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::removeItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module removeItem(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module removeItem(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    // IMPLEMENT: Operation
    return null;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::insertItemBefore</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module insertItemBefore(
      in ::edu::syr::npac::webflow::module::Module arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module insertItemBefore(
    edu.syr.npac.webflow.module.Module arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    // IMPLEMENT: Operation
    return null;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::setPersistentConnection</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void setPersistentConnection(
      in boolean arg0
    );
  </pre>
  </p>
  */
  public void setPersistentConnection(
    boolean arg0
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::isPersistentConnection</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    boolean isPersistentConnection();
  </pre>
  </p>
  */
  public boolean isPersistentConnection() {
    // IMPLEMENT: Operation
    return false;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::compute</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void compute(
    )
    raises(
      ::edu::syr::npac::webflow::exception::webflowException
    );
  </pre>
  </p>
  */
  public void compute(
  ) throws
    edu.syr.npac.webflow.exception.webflowException {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::setConnectionInfo</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void setConnectionInfo(
      in string arg0
    );
  </pre>
  </p>
  */
  public void setConnectionInfo(
    java.lang.String arg0
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addNode(
      in string arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public void addNode(
    java.lang.String arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::removeNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void removeNode(
      in string arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public void removeNode(
    java.lang.String arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    // IMPLEMENT: Operation
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::getNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module getNode(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module getNode(
    java.lang.String arg0
  ) {
    // IMPLEMENT: Operation
    return null;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::invoke</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::java::lang::Object invoke(
      in string arg0,
      in string arg1
    );
  </pre>
  </p>
  */
  public java.lang.Object invoke(
    java.lang.String arg0,
    java.lang.String arg1
  ) {
    // IMPLEMENT: Operation
    return null;
  }
}
