package edu.syr.npac.webflow.manager;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.manager._tie_moduleManager
<li> <b>Source File</b> edu/syr/npac/webflow/manager/_tie_moduleManager.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::manager::moduleManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/manager/moduleManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/manager"
    interface moduleManager {
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
        in ::java::lang::Object arg0
      );
      Object getModuleHandle(
        in string arg0
      );
      ::edu::syr::npac::webflow::module::Module createTransientModule(
        in string arg0
      );
    };
</pre>
</p>
*/
public class _tie_moduleManager extends edu.syr.npac.webflow.manager._moduleManagerImplBase {
  private edu.syr.npac.webflow.manager.moduleManagerOperations _delegate;
  public _tie_moduleManager(edu.syr.npac.webflow.manager.moduleManagerOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_moduleManager(edu.syr.npac.webflow.manager.moduleManagerOperations delegate) {
    this._delegate = delegate;
  }
  public edu.syr.npac.webflow.manager.moduleManagerOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listModules</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
  </pre>
  </p>
  */
  public java.lang.String[] listModules() {
    return this._delegate.listModules(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listMethods</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public java.lang.String[] listMethods(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    return this._delegate.listMethods(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listZeroArgumentMethods</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
      in ::java::lang::Object arg0
    );
  </pre>
  </p>
  */
  public java.lang.String[] listZeroArgumentMethods(
    java.lang.Object arg0
  ) {
    return this._delegate.listZeroArgumentMethods(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::getModuleHandle</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    Object getModuleHandle(
      in string arg0
    );
  </pre>
  </p>
  */
  public org.omg.CORBA.Object getModuleHandle(
    java.lang.String arg0
  ) {
    return this._delegate.getModuleHandle(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::createTransientModule</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::module::Module createTransientModule(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module createTransientModule(
    java.lang.String arg0
  ) {
    return this._delegate.createTransientModule(
      arg0
    );
  }
}
