package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging.ImageModuleHelper
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/ImageModuleHelper.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageModule : ::edu::syr::npac::webflow::module::Module {
      void setWidth(
        in long arg0
      );
      long getWidth();
      void setHeight(
        in long arg0
      );
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      void setPixels(
        in ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long arg0
      );
      ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
abstract public class ImageModuleHelper {
  public static edu.syr.npac.webflow.module.imaging.ImageModule narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static edu.syr.npac.webflow.module.imaging.ImageModule narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof edu.syr.npac.webflow.module.imaging.ImageModule) {
      return (edu.syr.npac.webflow.module.imaging.ImageModule) object;
    }
    if(is_a || object._is_a(id())) {
      edu.syr.npac.webflow.module.imaging._st_ImageModule result = (edu.syr.npac.webflow.module.imaging._st_ImageModule)new edu.syr.npac.webflow.module.imaging._st_ImageModule();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (edu.syr.npac.webflow.module.imaging.ImageModule) result._this();
    }
    return null;
  }
  public static edu.syr.npac.webflow.module.imaging.ImageModule bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static edu.syr.npac.webflow.module.imaging.ImageModule bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static edu.syr.npac.webflow.module.imaging.ImageModule bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static edu.syr.npac.webflow.module.imaging.ImageModule read(org.omg.CORBA.portable.InputStream _input) {
    return edu.syr.npac.webflow.module.imaging.ImageModuleHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, edu.syr.npac.webflow.module.imaging.ImageModule value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, edu.syr.npac.webflow.module.imaging.ImageModule value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static edu.syr.npac.webflow.module.imaging.ImageModule extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "ImageModule");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:edu/syr/npac/webflow/module/imaging/ImageModule:1.0";
  }
}
