package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging._st_ImageModule
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/_st_ImageModule.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageModule : ::edu::syr::npac::webflow::module::Module {
      void setWidth(
        in long arg0
      );
      long getWidth();
      void setHeight(
        in long arg0
      );
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      void setPixels(
        in ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long arg0
      );
      ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
public class _st_ImageModule extends edu.syr.npac.webflow.module._st_Module implements edu.syr.npac.webflow.module.imaging.ImageModule {
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/module/imaging/ImageModule:1.0",
    "IDL:edu/syr/npac/webflow/module/Module:1.0"
  };
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setWidth</b>.
  <pre>
    void setWidth(
      in long arg0
    );
  </pre>
  </p>
  */
  public void setWidth(
    int arg0
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("setWidth", true);
      _output.write_long(arg0);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      setWidth(
        arg0
      );
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getWidth</b>.
  <pre>
    long getWidth();
  </pre>
  </p>
  */
  public int getWidth() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getWidth", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getWidth();
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setHeight</b>.
  <pre>
    void setHeight(
      in long arg0
    );
  </pre>
  </p>
  */
  public void setHeight(
    int arg0
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("setHeight", true);
      _output.write_long(arg0);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      setHeight(
        arg0
      );
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getHeight</b>.
  <pre>
    long getHeight();
  </pre>
  </p>
  */
  public int getHeight() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getHeight", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getHeight();
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::setPixels</b>.
  <pre>
    void setPixels(
      in ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long arg0
    );
  </pre>
  </p>
  */
  public void setPixels(
    int[] arg0
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("setPixels", true);
      edu.syr.npac.webflow.module.imaging.ImageModulePackage.sequence_of_longHelper.write(_output, arg0);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      setPixels(
        arg0
      );
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageModule::getPixels</b>.
  <pre>
    ::edu::syr::npac::webflow::module::imaging::ImageModule::sequence_of_long getPixels();
  </pre>
  </p>
  */
  public int[] getPixels() {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("getPixels", true);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int[] _result;
      _result = edu.syr.npac.webflow.module.imaging.ImageModulePackage.sequence_of_longHelper.read(_input);
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return getPixels();
    }
  }
}
