/*
 * File: ./ClientServer/_TransactionImplBase.java
 * From: ClientServer.idl
 * Date: Mon Mar 16 11:42:22 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ClientServer;
public abstract class _TransactionImplBase extends org.omg.CORBA.DynamicImplementation implements ClientServer.Transaction {
    // Constructor
    public _TransactionImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:ClientServer/Transaction:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("queryCheckingAccount", new java.lang.Integer(0));
      _methods.put("querySavingAccount", new java.lang.Integer(1));
      _methods.put("transferFromCheckingToSaving", new java.lang.Integer(2));
      _methods.put("transferFromSavingToChecking", new java.lang.Integer(3));
      _methods.put("beeping", new java.lang.Integer(4));
      _methods.put("setTime", new java.lang.Integer(5));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // ClientServer.Transaction.queryCheckingAccount
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _tr = _orb().create_any();
              _tr.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("tr", _tr, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long tr;
              tr = _tr.extract_longlong();
              String ___result;
                            ___result = this.queryCheckingAccount(tr);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 1: // ClientServer.Transaction.querySavingAccount
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _tr = _orb().create_any();
              _tr.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("tr", _tr, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long tr;
              tr = _tr.extract_longlong();
              String ___result;
                            ___result = this.querySavingAccount(tr);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 2: // ClientServer.Transaction.transferFromCheckingToSaving
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _tr = _orb().create_any();
              _tr.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("tr", _tr, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _amount = _orb().create_any();
              _amount.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("amount", _amount, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long tr;
              tr = _tr.extract_longlong();
              float amount;
              amount = _amount.extract_float();
              String ___result;
                            ___result = this.transferFromCheckingToSaving(tr, amount);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 3: // ClientServer.Transaction.transferFromSavingToChecking
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _tr = _orb().create_any();
              _tr.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("tr", _tr, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _amount = _orb().create_any();
              _amount.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_float));
              _list.add_value("amount", _amount, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long tr;
              tr = _tr.extract_longlong();
              float amount;
              amount = _amount.extract_float();
              String ___result;
                            ___result = this.transferFromSavingToChecking(tr, amount);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 4: // ClientServer.Transaction.beeping
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _beeps = _orb().create_any();
              _beeps.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("beeps", _beeps, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              long beeps;
              beeps = _beeps.extract_longlong();
              boolean ___result;
                            ___result = this.beeping(beeps);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 5: // ClientServer.Transaction.setTime
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _timein = _orb().create_any();
              _timein.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("timein", _timein, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String timein;
              timein = _timein.extract_string();
                            this.setTime(timein);
              org.omg.CORBA.Any __return = _orb().create_any();
              __return.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_void));
              r.result(__return);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
