/*
 * File: ./ClientServer/_TransactionStub.java
 * From: ClientServer.idl
 * Date: Mon Mar 16 11:42:22 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ClientServer;
public class _TransactionStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements ClientServer.Transaction {

    public _TransactionStub(org.omg.CORBA.portable.Delegate d) {
          super();
          _set_delegate(d);
    }

    private static final String _type_ids[] = {
        "IDL:ClientServer/Transaction:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    //	IDL operations
    //	    Implementation of ::ClientServer::Transaction::queryCheckingAccount
    public String queryCheckingAccount(long tr)
 {
           org.omg.CORBA.Request r = _request("queryCheckingAccount");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _tr = r.add_in_arg();
           _tr.insert_longlong(tr);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ClientServer::Transaction::querySavingAccount
    public String querySavingAccount(long tr)
 {
           org.omg.CORBA.Request r = _request("querySavingAccount");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _tr = r.add_in_arg();
           _tr.insert_longlong(tr);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ClientServer::Transaction::transferFromCheckingToSaving
    public String transferFromCheckingToSaving(long tr, float amount)
 {
           org.omg.CORBA.Request r = _request("transferFromCheckingToSaving");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _tr = r.add_in_arg();
           _tr.insert_longlong(tr);
           org.omg.CORBA.Any _amount = r.add_in_arg();
           _amount.insert_float(amount);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ClientServer::Transaction::transferFromSavingToChecking
    public String transferFromSavingToChecking(long tr, float amount)
 {
           org.omg.CORBA.Request r = _request("transferFromSavingToChecking");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _tr = r.add_in_arg();
           _tr.insert_longlong(tr);
           org.omg.CORBA.Any _amount = r.add_in_arg();
           _amount.insert_float(amount);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ClientServer::Transaction::beeping
    public boolean beeping(long beeps)
 {
           org.omg.CORBA.Request r = _request("beeping");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _beeps = r.add_in_arg();
           _beeps.insert_longlong(beeps);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ClientServer::Transaction::setTime
    public void setTime(String timein)
 {
           org.omg.CORBA.Request r = _request("setTime");
           org.omg.CORBA.Any _timein = r.add_in_arg();
           _timein.insert_string(timein);
           r.invoke();
   }

};
