/*
 * File: ./ConsoleCoordinator/_CoordinatorManagerImplBase.java
 * From: ConsoleCoordinator.idl
 * Date: Tue Mar  3 13:44:44 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ConsoleCoordinator;
public abstract class _CoordinatorManagerImplBase extends org.omg.CORBA.DynamicImplementation implements ConsoleCoordinator.CoordinatorManager {
    // Constructor
    public _CoordinatorManagerImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:ConsoleCoordinator/CoordinatorManager:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("nextRegister", new java.lang.Integer(0));
      _methods.put("numServers", new java.lang.Integer(1));
      _methods.put("startup", new java.lang.Integer(2));
      _methods.put("shutdown", new java.lang.Integer(3));
      _methods.put("refresh", new java.lang.Integer(4));
      _methods.put("authentication", new java.lang.Integer(5));
      _methods.put("checkServerStatus", new java.lang.Integer(6));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // ConsoleCoordinator.CoordinatorManager.nextRegister
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              ConsoleCoordinator.Register ___result;
                            ___result = this.nextRegister();
              org.omg.CORBA.Any __result = _orb().create_any();
              ConsoleCoordinator.RegisterHelper.insert(__result, ___result);
              r.result(__result);
              }
              break;
           case 1: // ConsoleCoordinator.CoordinatorManager.numServers
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              int ___result;
                            ___result = this.numServers();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_long(___result);
              r.result(__result);
              }
              break;
           case 2: // ConsoleCoordinator.CoordinatorManager.startup
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              boolean ___result;
                            ___result = this.startup();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 3: // ConsoleCoordinator.CoordinatorManager.shutdown
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              boolean ___result;
                            ___result = this.shutdown();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 4: // ConsoleCoordinator.CoordinatorManager.refresh
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              String ___result;
                            ___result = this.refresh();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_string(___result);
              r.result(__result);
              }
              break;
           case 5: // ConsoleCoordinator.CoordinatorManager.authentication
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _username = _orb().create_any();
              _username.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("username", _username, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _password = _orb().create_any();
              _password.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("password", _password, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String username;
              username = _username.extract_string();
              String password;
              password = _password.extract_string();
              boolean ___result;
                            ___result = this.authentication(username, password);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 6: // ConsoleCoordinator.CoordinatorManager.checkServerStatus
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              boolean ___result;
                            ___result = this.checkServerStatus();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
