/*
 * File: ./CoordinatorServer/_AcknowledgeImplBase.java
 * From: CoordinatorServer.idl
 * Date: Fri Mar  6 10:19:13 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package CoordinatorServer;
public abstract class _AcknowledgeImplBase extends org.omg.CORBA.DynamicImplementation implements CoordinatorServer.Acknowledge {
    // Constructor
    public _AcknowledgeImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:CoordinatorServer/Acknowledge:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("announceClientInfo", new java.lang.Integer(0));
      _methods.put("numActiveClients", new java.lang.Integer(1));
      _methods.put("numMaxClients", new java.lang.Integer(2));
      _methods.put("checkServer", new java.lang.Integer(3));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // CoordinatorServer.Acknowledge.announceClientInfo
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _userName = _orb().create_any();
              _userName.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("userName", _userName, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _password = _orb().create_any();
              _password.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("password", _password, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _trNo = _orb().create_any();
              _trNo.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_longlong));
              _list.add_value("trNo", _trNo, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String userName;
              userName = _userName.extract_string();
              String password;
              password = _password.extract_string();
              long trNo;
              trNo = _trNo.extract_longlong();
              boolean ___result;
                            ___result = this.announceClientInfo(userName, password, trNo);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 1: // CoordinatorServer.Acknowledge.numActiveClients
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              int ___result;
                            ___result = this.numActiveClients();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_long(___result);
              r.result(__result);
              }
              break;
           case 2: // CoordinatorServer.Acknowledge.numMaxClients
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              int ___result;
                            ___result = this.numMaxClients();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_long(___result);
              r.result(__result);
              }
              break;
           case 3: // CoordinatorServer.Acknowledge.checkServer
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              boolean ___result;
                            ___result = this.checkServer();
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
