import java.awt.*;
import java.awt.event.*;

class 
ConfirmFrame extends Frame {  
    private Button       YesButton;
    private Button       NoButton;
    private Label        messageLabel;

    public ConfirmFrame(ActionListener al) {
        setSize(300, 150);
        GridBagLayout gb = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setLayout(gb);

        gbc.anchor      = GridBagConstraints.NORTH;
        gbc.fill        = GridBagConstraints.NONE;
        gbc.gridwidth   = 2;
        gbc.gridheight  = 1;
        gbc.gridx       = 0;
        gbc.gridy       = 0;
        messageLabel = new Label("", Label.CENTER);
        messageLabel.setFont(new Font("Helvetica", Font.BOLD, 12));
        gb.setConstraints(messageLabel, gbc);
        add(messageLabel);

        gbc.anchor      = GridBagConstraints.SOUTH;
        gbc.gridwidth   = 1;
        gbc.gridy       = 6;
        YesButton = new Button("Yes");
        YesButton.addActionListener(al);
        gb.setConstraints(YesButton, gbc);
        add(YesButton);

        gbc.gridx       = 1;
        NoButton = new Button("No");
        NoButton.addActionListener(al);
        gb.setConstraints(NoButton, gbc);
        add(NoButton);
    }

    public void
    setMessage(String operation, String dest) {
        messageLabel.setText("Are you sure about " + operation +
                             " " + dest + "?");
    }
}
