/*
 * File: ./ConsoleCoordinator/_CoordinatorManagerStub.java
 * From: ConsoleCoordinator.idl
 * Date: Tue May  5 13:18:37 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ConsoleCoordinator;
public class _CoordinatorManagerStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements ConsoleCoordinator.CoordinatorManager {

    public _CoordinatorManagerStub(org.omg.CORBA.portable.Delegate d) {
          super();
          _set_delegate(d);
    }

    private static final String _type_ids[] = {
        "IDL:ConsoleCoordinator/CoordinatorManager:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    //	IDL operations
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::numServers
    public int numServers()
 {
           org.omg.CORBA.Request r = _request("numServers");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_long));
           r.invoke();
           int __result;
           __result = r.return_value().extract_long();
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::startup
    public boolean startup()
 {
           org.omg.CORBA.Request r = _request("startup");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::shutdown
    public boolean shutdown()
 {
           org.omg.CORBA.Request r = _request("shutdown");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::refresh
    public String[] refresh()
 {
           org.omg.CORBA.Request r = _request("refresh");
           r.set_return_type(ConsoleCoordinator.StringArrayHelper.type());
           r.invoke();
           String[] __result;
           __result = ConsoleCoordinator.StringArrayHelper.extract(r.return_value());
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::authentication
    public boolean authentication(String username, String password)
 {
           org.omg.CORBA.Request r = _request("authentication");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _username = r.add_in_arg();
           _username.insert_string(username);
           org.omg.CORBA.Any _password = r.add_in_arg();
           _password.insert_string(password);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::start
    public boolean start(int id)
 {
           org.omg.CORBA.Request r = _request("start");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _id = r.add_in_arg();
           _id.insert_long(id);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ConsoleCoordinator::CoordinatorManager::stop
    public boolean stop(int id)
 {
           org.omg.CORBA.Request r = _request("stop");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _id = r.add_in_arg();
           _id.insert_long(id);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }

};
