/*
 * File: ./ICoordinatorDB/_AdminDBServiceStub.java
 * From: ICoordinatorDB.idl
 * Date: Mon Mar 23 15:34:35 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package ICoordinatorDB;
public class _AdminDBServiceStub
	extends org.omg.CORBA.portable.ObjectImpl
    	implements ICoordinatorDB.AdminDBService {

    public _AdminDBServiceStub(org.omg.CORBA.portable.Delegate d) {
          super();
          _set_delegate(d);
    }

    private static final String _type_ids[] = {
        "IDL:ICoordinatorDB/AdminDBService:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    //	IDL operations
    //	    Implementation of ::ICoordinatorDB::AdminDBService::addUser
    public boolean addUser(String userid, String lastName, String firstName, String address, String hPhone, String wPhone, String status, float checking, float saving, String time, String zone)
 {
           org.omg.CORBA.Request r = _request("addUser");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _userid = r.add_in_arg();
           _userid.insert_string(userid);
           org.omg.CORBA.Any _lastName = r.add_in_arg();
           _lastName.insert_string(lastName);
           org.omg.CORBA.Any _firstName = r.add_in_arg();
           _firstName.insert_string(firstName);
           org.omg.CORBA.Any _address = r.add_in_arg();
           _address.insert_string(address);
           org.omg.CORBA.Any _hPhone = r.add_in_arg();
           _hPhone.insert_string(hPhone);
           org.omg.CORBA.Any _wPhone = r.add_in_arg();
           _wPhone.insert_string(wPhone);
           org.omg.CORBA.Any _status = r.add_in_arg();
           _status.insert_string(status);
           org.omg.CORBA.Any _checking = r.add_in_arg();
           _checking.insert_float(checking);
           org.omg.CORBA.Any _saving = r.add_in_arg();
           _saving.insert_float(saving);
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::deleteUser
    public boolean deleteUser(String userid, String time, String zone)
 {
           org.omg.CORBA.Request r = _request("deleteUser");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _userid = r.add_in_arg();
           _userid.insert_string(userid);
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::searchUser
    public String searchUser(String userid, String lastName, String firstName, String hPhone)
 {
           org.omg.CORBA.Request r = _request("searchUser");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _userid = r.add_in_arg();
           _userid.insert_string(userid);
           org.omg.CORBA.Any _lastName = r.add_in_arg();
           _lastName.insert_string(lastName);
           org.omg.CORBA.Any _firstName = r.add_in_arg();
           _firstName.insert_string(firstName);
           org.omg.CORBA.Any _hPhone = r.add_in_arg();
           _hPhone.insert_string(hPhone);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::showBalance
    public String showBalance(String userid)
 {
           org.omg.CORBA.Request r = _request("showBalance");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
           org.omg.CORBA.Any _userid = r.add_in_arg();
           _userid.insert_string(userid);
           r.invoke();
           String __result;
           __result = r.return_value().extract_string();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::updateUser
    public boolean updateUser(String userid, String lastName, String firstName, String address, String hPhone, String wPhone, String status, float checking, float saving, String time, String zone)
 {
           org.omg.CORBA.Request r = _request("updateUser");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _userid = r.add_in_arg();
           _userid.insert_string(userid);
           org.omg.CORBA.Any _lastName = r.add_in_arg();
           _lastName.insert_string(lastName);
           org.omg.CORBA.Any _firstName = r.add_in_arg();
           _firstName.insert_string(firstName);
           org.omg.CORBA.Any _address = r.add_in_arg();
           _address.insert_string(address);
           org.omg.CORBA.Any _hPhone = r.add_in_arg();
           _hPhone.insert_string(hPhone);
           org.omg.CORBA.Any _wPhone = r.add_in_arg();
           _wPhone.insert_string(wPhone);
           org.omg.CORBA.Any _status = r.add_in_arg();
           _status.insert_string(status);
           org.omg.CORBA.Any _checking = r.add_in_arg();
           _checking.insert_float(checking);
           org.omg.CORBA.Any _saving = r.add_in_arg();
           _saving.insert_float(saving);
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::open
    public boolean open(String username, String password, String time, String zone)
 {
           org.omg.CORBA.Request r = _request("open");
           r.set_return_type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean));
           org.omg.CORBA.Any _username = r.add_in_arg();
           _username.insert_string(username);
           org.omg.CORBA.Any _password = r.add_in_arg();
           _password.insert_string(password);
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
           boolean __result;
           __result = r.return_value().extract_boolean();
           return __result;
   }
    //	    Implementation of ::ICoordinatorDB::AdminDBService::close
    public void close(String time, String zone)
 {
           org.omg.CORBA.Request r = _request("close");
           org.omg.CORBA.Any _time = r.add_in_arg();
           _time.insert_string(time);
           org.omg.CORBA.Any _zone = r.add_in_arg();
           _zone.insert_string(zone);
           r.invoke();
   }

};
