/*
 * File: ./MonitorServer/_MonitorImplBase.java
 * From: MonitorServer.idl
 * Date: Thu May 14 11:44:27 1998
 *   By: idltojava Java IDL 1.2 Nov 12 1997 12:23:47
 */

package MonitorServer;
public abstract class _MonitorImplBase extends org.omg.CORBA.DynamicImplementation implements MonitorServer.Monitor {
    // Constructor
    public _MonitorImplBase() {
         super();
    }
    // Type strings for this class and its superclases
    private static final String _type_ids[] = {
        "IDL:MonitorServer/Monitor:1.0"
    };

    public String[] _ids() { return (String[]) _type_ids.clone(); }

    private static java.util.Dictionary _methods = new java.util.Hashtable();
    static {
      _methods.put("connect", new java.lang.Integer(0));
      _methods.put("getActiveServiceStatus", new java.lang.Integer(1));
      _methods.put("getIdleServiceStatus", new java.lang.Integer(2));
      _methods.put("moveUp", new java.lang.Integer(3));
      _methods.put("moveDown", new java.lang.Integer(4));
     }
    // DSI Dispatch call
    public void invoke(org.omg.CORBA.ServerRequest r) {
       switch (((java.lang.Integer) _methods.get(r.op_name())).intValue()) {
           case 0: // MonitorServer.Monitor.connect
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _username = _orb().create_any();
              _username.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("username", _username, org.omg.CORBA.ARG_IN.value);
              org.omg.CORBA.Any _password = _orb().create_any();
              _password.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_string));
              _list.add_value("password", _password, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              String username;
              username = _username.extract_string();
              String password;
              password = _password.extract_string();
              boolean ___result;
                            ___result = this.connect(username, password);
              org.omg.CORBA.Any __result = _orb().create_any();
              __result.insert_boolean(___result);
              r.result(__result);
              }
              break;
           case 1: // MonitorServer.Monitor.getActiveServiceStatus
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              String[] ___result;
                            ___result = this.getActiveServiceStatus();
              org.omg.CORBA.Any __result = _orb().create_any();
              MonitorServer.StringArrayHelper.insert(__result, ___result);
              r.result(__result);
              }
              break;
           case 2: // MonitorServer.Monitor.getIdleServiceStatus
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              r.params(_list);
              String[] ___result;
                            ___result = this.getIdleServiceStatus();
              org.omg.CORBA.Any __result = _orb().create_any();
              MonitorServer.StringArrayHelper.insert(__result, ___result);
              r.result(__result);
              }
              break;
           case 3: // MonitorServer.Monitor.moveUp
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _id = _orb().create_any();
              _id.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_long));
              _list.add_value("id", _id, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              int id;
              id = _id.extract_long();
                            this.moveUp(id);
              org.omg.CORBA.Any __return = _orb().create_any();
              __return.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_void));
              r.result(__return);
              }
              break;
           case 4: // MonitorServer.Monitor.moveDown
              {
              org.omg.CORBA.NVList _list = _orb().create_list(0);
              org.omg.CORBA.Any _id = _orb().create_any();
              _id.type(org.omg.CORBA.ORB.init().get_primitive_tc(org.omg.CORBA.TCKind.tk_long));
              _list.add_value("id", _id, org.omg.CORBA.ARG_IN.value);
              r.params(_list);
              int id;
              id = _id.extract_long();
                            this.moveDown(id);
              org.omg.CORBA.Any __return = _orb().create_any();
              __return.type(_orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_void));
              r.result(__return);
              }
              break;
            default:
              throw new org.omg.CORBA.BAD_OPERATION(0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
       }
 }
}
