package JSci.maths;

/**
* The Algebra class provides an abstract encapsulation for algebras.
* @version 1.1
* @author Mark Hale
*/
public abstract class Algebra extends VectorSpace {
        /**
        * Constructs an algebra.
        */
        public Algebra() {
        }
        /**
        * The vector multiplication law.
        * @param a a vector
        * @param b a vector
        */
        public abstract Object vectorMultiplication(Object a, Object b);
}

