package JSci.maths;

/**
* The Matrix superclass provides an abstract encapsulation for matrices.
* @version 1.5
* @author Mark Hale
*/
public abstract class Matrix extends Object {
        /**
        * Constructs a matrix.
        */
        public Matrix() {}
        /**
        * Returns the number of rows.
        */
        public abstract int rows();
        /**
        * Returns the number of columns.
        */
        public abstract int columns();
}

