/*  Site.class is used for http document links within applets */

import java.awt.*;
import java.net.*;

class Site extends Button {
	private String title;
	private URL location;

	public Site(String siteTitle, String siteLocation)	//
	{
		title = siteTitle;

		try {
			location = new URL(siteLocation);
		}
		catch (MalformedURLException e) {
			System.err.println("Invalid URL: " + siteLocation);
		}

	}

	public String getTitle()  {return title;}
	public URL getLocation() {return location;}
}//end class