/*	
	mframe.class 
					written by Fisayo Omojokun -- s0oaomoj@atlas.vcu.edu

	This class generates the external window frame used in the mydriver applet.
	It creates a window used to explain the actions occuring in the applet.
	It is set as a child class of Thread because of the need to keep the frame
	visible as much as possible.
*/

import java.awt.*;

public class mframe extends Thread {

//vars declaration

	Frame Teachframe = new Frame("READ ME! READ ME! READ ME!");		// external frame
	private Font ff;

	String Teach[];									//array of strings which explain actions

	String mstatus[];								//simulates showstatus of applet. will display
													//information needed by viewer
		
	Label showTeach;								//string currently being shown
	Label ss;										//status currently being shown
		
	private int i=0;								//array index, which is currently being shown
	
	private int fl = 140, fw = 602;					//frame length, frame width
	private int tfl = 5, tfw = 63;					//textfield length, textfield width

	TextArea learn;									//Text area showing explaination

//end vars
	
	public void initialize()  {						// NOT init(); just initializes class pieces on call
		
		Teachframe.setResizable(true);
		Teachframe.setBackground(Color.white);
	 
		
		Teach = new String[7];						//array of explanations
		mstatus = new String[7];					//array of status some empty to allow
													//an association b/w teach and mstatus indexes

//initialize strings with explanations

		Teach[0] = ("The client visits the web page containing the HTML form");
		Teach[1] = ("The submission of form creates a sent request to the server");
		Teach[2] = ("Server takes in request and decides action.\n" + 
					"In the case of an html form ...");
		Teach[3] = (" ... the server retrieves the executable CGI Program and\n" +
				   "passes parameters of request to the program for execution");
		Teach[4] = ("The CGI program parses the input and generates a response\n" +
				   "back to the server.  CGI programs can be written in several\n" +
				   "languages.  (The voting ballot example was written with Perl.)");
		Teach[5] = ("From the response, the server sends a formated html page,\n" +
				   "created by the CGI program, to the client.");
		Teach[6] = ("Client recieves page in browser and server closes connection");

		mstatus[0] = ("Click on the HTML form icon to view an already filled example form. Return to applet with brower [BACK] or [PREVIOUS] button.");
		mstatus[1] = ("");
		mstatus[2] = ("");
		mstatus[3] = ("Click on CGI program icon to view the source code for the example form's CGI program.");
		mstatus[4] = ("");
		mstatus[5] = ("Click on HTML response icon to view a sample response generated by CGI program.");
		mstatus[6] = ("Animation done- Click on the [Try your own ballot] button to fill your own ballot");



//end string initializaitons	
		
		Teachframe.setLayout(new BorderLayout() );
		Teachframe.resize(fw,fl);

//text area setup

		learn = new TextArea(Teach[i],tfl,tfw);			
		learn.setEditable(false);
   		ff = new Font("Courier",Font.BOLD,15);
		learn.setFont(ff);
		
		Teachframe.add("North",learn);
		ss = new Label(mstatus[i]);
		Teachframe.add("South",ss);
		i++;

	}	//end init

	public boolean handleEvent( Event ex)  {
		
		if (ex.id == Event.WINDOW_DESTROY ) {
			Teachframe.hide();
			Teachframe.dispose();
			System.exit(0);
	
		}//end if
		return Teachframe.handleEvent(ex);
	}//end handleevent

	public void putFront()  {		//make frame visible

		if (Teachframe != null)  
			Teachframe.show();

	}//END PUT FRONT
		

	public void endframe() {				//flushes frame

			Teachframe.hide();
			Teachframe.dispose();
			
	}//end endframe




	public void run() {				//thread run
		
		if (i == 0) 
			initialize();
		Teachframe.pack();		//fit tightly
		
		Teachframe.move(420,17);
		
		Teachframe.show();
		Teachframe.toFront();



	}//end run

	public void changeText() {				//procedure disposes and changes explanation on call
		
		if (Teachframe != null)  {
			Teachframe.hide();
			Teachframe.dispose();
		}

		Teachframe = new Frame("READ ME! READ ME! READ ME!");
		Teachframe.setLayout(new BorderLayout() );
		Teachframe.resize(fw,fl);
		Teachframe.setBackground(Color.white);


		learn = new TextArea(tfl,tfw);
		learn.setEditable(false);	

		learn.setText(Teach[i]);
		ff = new Font("Courier",Font.BOLD,15);
		learn.setFont(ff);

		ss = new Label(mstatus[i]);
		Teachframe.add("North",learn);
		Teachframe.add("South",ss);
 		
		Teachframe.pack();
		Teachframe.move(420,17);
		Teachframe.show();
		Teachframe.toFront();
 		
		learn.setFont(ff);
		i++;	//move to next string

	}//end change text

}//end mframe


	