/*	
	mstring.class 
					written by Fisayo Omojokun -- s0oaomoj@atlas.vcu.edu

	This class, similar to mboxtext, creates a moveable text object
				
				  see mboxtext
*/


import java.awt.*;


public class mstring  {
//vars declaration

	private int x,y;		//x and y positions
	private String mtext;	//text to show
	private Font tf;
	private Color tcolor;	//textcolor

//end vars

	public mstring(int _x, int _y, Color _c, String _mtext, int fs)  {		//end constructors

		setX(_x);
		setY(_y);

		tcolor = _c;
		tf = new Font("TimesRoman",Font.BOLD, fs);
		setTexT(_mtext);

	}//end constructor


	public void setX(int toX)  {
		x = toX;
	}//end setX

	public int getX()  {
		return x;
	}//end getX

	public void setY(int toY)  {
		y = toY;
	}//end setY

	public int getY()  {
		return y;
	}//end getY

	protected void setColor(Color toC)  {
		tcolor = toC;
	}//end setColor


	public void setTexT(String newT)   {
		mtext = new String(newT); //create new string and initialize it to set value
	}//end setTexT

	public void show(Graphics offg)    {  //show on given context
		offg.setColor(tcolor);

		offg.setFont(tf);
		offg.drawString(mtext,x,y);

	}//end show

}//end mstring