print "Enter a temperature (e.g., 32F or 100C):\n";
$input = <STDIN>; chomp( $input );

if ( $input =~ m/^([-+]?\d+)([CF])$/ ) {
  $temp = $1; $type = $2;
  if ( $type eq "C" ) {
    $celsius = $temp;
    $fahrenheit = ( $celsius * 9/5 ) + 32;
  } else {
    $fahrenheit = $temp;
    $celsius = ( $fahrenheit - 32 ) * 5/9;
  }
  printf "%.2f C = %.2f F\n", $celsius, $fahrenheit;
} else {
  print "Expecting a temperature, not \"$input\"\n";
}
