package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util._st_RandomGen
<li> <b>Source File</b> cis600/util/_st_RandomGen.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
public class _st_RandomGen extends org.omg.CORBA.portable.ObjectImpl implements cis600.util.RandomGen {
  protected cis600.util.RandomGen _wrapper = null;
  public cis600.util.RandomGen _this() {
    return this;
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:cis600/util/RandomGen:1.0"
  };
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextInt</b>.
  <pre>
    long nextInt(
      in long arg0
    );
  </pre>
  </p>
  */
  public int nextInt(
    int arg0
  ) {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("nextInt", true);
      _output.write_long(arg0);
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, null);
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return nextInt(
        arg0
      );
    }
  }
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextIntInRange</b>.
  <pre>
    long nextIntInRange(
      in long arg0,
      in long arg1
    )
    raises(
      ::cis600::util::InvalidOperationException
    );
  </pre>
  </p>
  */
  public int nextIntInRange(
    int arg0,
    int arg1
  ) throws
    cis600.util.InvalidOperationException {
    try {
      org.omg.CORBA.portable.OutputStream _output = this._request("nextIntInRange", true);
      _output.write_long(arg0);
      _output.write_long(arg1);
      org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
      org.omg.CORBA.portable.InputStream _input = this._invoke(_output, _exception_id);
      if(_exception_id.value != null) {
        if(_exception_id.value.equals(cis600.util.InvalidOperationExceptionHelper.id())) {
          throw cis600.util.InvalidOperationExceptionHelper.read(_input);
        }
        throw new org.omg.CORBA.MARSHAL
          ("Unexpected User Exception: " + _exception_id.value);
      }
      int _result;
      _result = _input.read_long();
      return _result;
    }
    catch(org.omg.CORBA.TRANSIENT _exception) {
      return nextIntInRange(
        arg0,
        arg1
      );
    }
  }
}
