package cis600.util;
/**
<p>
<ul>
<li> <b>Java Class</b> cis600.util._tie_RandomGen
<li> <b>Source File</b> cis600/util/_tie_RandomGen.java
<li> <b>IDL Absolute Name</b> ::cis600::util::RandomGen
<li> <b>Repository Identifier</b> IDL:cis600/util/RandomGen:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface RandomGen {
      long nextInt(
        in long arg0
      );
      long nextIntInRange(
        in long arg0,
        in long arg1
      )
      raises(
        ::cis600::util::InvalidOperationException
      );
    };
</pre>
</p>
*/
public class _tie_RandomGen extends cis600.util._RandomGenImplBase {
  private cis600.util.RandomGenOperations _delegate;
  public _tie_RandomGen(cis600.util.RandomGenOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_RandomGen(cis600.util.RandomGenOperations delegate) {
    this._delegate = delegate;
  }
  public cis600.util.RandomGenOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextInt</b>.
  <pre>
    long nextInt(
      in long arg0
    );
  </pre>
  </p>
  */
  public int nextInt(
    int arg0
  ) {
    return this._delegate.nextInt(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::cis600::util::RandomGen::nextIntInRange</b>.
  <pre>
    long nextIntInRange(
      in long arg0,
      in long arg1
    )
    raises(
      ::cis600::util::InvalidOperationException
    );
  </pre>
  </p>
  */
  public int nextIntInRange(
    int arg0,
    int arg1
  ) throws
    cis600.util.InvalidOperationException {
    return this._delegate.nextIntInRange(
      arg0,
      arg1
    );
  }
}
