/*
 * Test Java Program
 */

import java.applet.*;
import java.awt.*;

public class Test extends Applet implements Runnable {
    Thread thread;
    public void init() {
    }
    /* start a new thread */
    public void start() {
        if (thread == null) {
          thread = new Thread(this);
          thread.start();
        }
    }
    /* stop the thread */
    public void stop() {
        if (thread != null) {
          thread.stop();
          thread = null;
        }
    }
    /* thread is working here */
    public void run() {
        while (thread != null) {
          try thread.sleep(1000);
          catch (InterruptedException e);
          System.out.println("thread is working...");
        }
    }
    public void paint(Graphics g) {
        /* draw a boundry */
        g.drawRect(0, 0, size().width-1, size().height-1);
    }
}
