/*
 * Test Java Program
 */

import java.applet.*;
import java.awt.*;

public class Test extends Applet implements Runnable {
    int maxObj = 2;     /* max object number */
    mPoint object[];    /* objecct array */
    Thread thread;
    Image img;
    public void init() {
      /* initial object array */
      object = new mPoint[maxObj];
      /* initial a rectangle */
      object[0] = new mRectangle(10, 10, 100, 100);
      object[0].setDelta(1, 1);
      object[0].setColor(Color.red);
      /* initial a circle */
      object[1] = new mRectangle(200, 10, 100, 100);
      object[1].setDelta(-1, 1);
      object[1].setColor(Color.blue);
      img = createImage(size().width, size().height);
    }
    /* start a new thread */
    public void start() {
        if (thread == null) {
          thread = new Thread(this);
          thread.start();
        }
    }
    /* stop the thread */
    public void stop() {
        if (thread != null) {
          thread.stop();
          thread = null;
        }
    }
    /* keep moving and redraw the objects */
    public void run() {
        while (thread != null) {
          try { thread.sleep(20); }
          catch (InterruptedException e) {}
          repaint();
        }
        
    }
    /* this method will be called to respond repaint() */
    public void update(Graphics g) {
        /* Get Off Screen Graphics Context */
        Graphics og = img.getGraphics(); 
        /* fill background */
        og.setColor(getBackground());
        og.fillRect(1, 1, size().width-2, size().height-2);
        /* draw boundry */
        og.setColor(getForeground());
        og.drawRect(0, 0, size().width-1, size().height-1);
        /* move object */
        for (int i=0; i<maxObj; i++) {
          object[i].checkBoundry(bounds());
          object[i].move(og);
        }
        /* user who call getGraphics should call dispose */
        og.dispose();
        g.drawImage(img, 0, 0, this);
    }
    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        update(g);
    }
}
