/*
 * intr006.java
 */

import java.applet.*;
import java.awt.*;
import java.net.*;

public class intr006 extends Applet {
    int current = 0;
    URL codBase;
    String tagName[] = {
      "Axial", "Sagittal", "Coronal", 
      "Low", "Medium", "High"};
    ImageCanvas logo;
    Button3D npac, tagBtn[];
    ImageSelector select[];
    Panel3D view[], board;
    int sliceNo[] = { 860, 350, 600};
    public void init() {
        int i;
        String arg;
        select = new ImageSelector[3];
        tagBtn = new Button3D[3];
        view = new Panel3D[4];
        codBase = getCodeBase();
        setLayout(new BorderLayout());
        logo = new ImageCanvas();
        logo.setPreferredSize(59, 59);
        logo.mode = 1;
        select[0] = new ImageSelector(Scrollbar.HORIZONTAL, sliceNo[0], 0, 1728);
        select[0].setValue(sliceNo[0], false);
        select[0].setPreferredSize(100, 59);
        select[0].mode = 1;
        select[1] = new ImageSelector(Scrollbar.HORIZONTAL, sliceNo[1], 0, 1000);
        select[1].setValue(sliceNo[1], false);
        select[1].setPreferredSize(59, 317);
        select[1].mode = 1;
        select[2] = new ImageSelector(Scrollbar.VERTICAL, sliceNo[2], 0, 1878);
        select[2].setValue(sliceNo[2], false);
        select[2].setPreferredSize(100, 317);
        select[2].mode = 1;
        npac = new Button3D("NPAC");
        view[3] = new Panel3D(0);
        view[3].setLayout(new BorderLayout());
        view[3].add("South", npac);
        view[3].add("Center", logo);
        board = new Panel3D();
        board.add(view[3]);
        for (i=0; i<3; i++) {
          view[i] = new Panel3D(0);
          view[i].setLayout(new BorderLayout());
          view[i].add("South", tagBtn[i] =
            new Button3D(Button3D.CHECKBTN, tagName[i]));
          view[i].add("Center", select[i]);
          tagBtn[i].setRatio(2);
          board.add(view[i]);
        }
        add("Center", board);
        setCurrent(2);
    }
    public void start() {
        /* Setup Image into Image Object */
        logo.updateImage(getImage(codBase, "logo.gif"));
        select[0].updateImage(getImage(codBase, "a_vm1114-18.jpg"));
        select[1].updateImage(getImage(codBase, "a_vmX1048-18.jpg"));
        select[2].updateImage(getImage(codBase, "a_vmY1020-18.jpg"));
    }
    private void setCurrent(int _current) {
        /* Select the current Viewport */
        if ( current == _current ) return;
        int i, k;
        current = _current;
        k = (current+1)%3;
        showStatus("Select "+tagName[k]+" View");
        for (i=0; i<3; i++) {
          tagBtn[i].setActive(i!=k);
          select[i].setMode((i==k) ? -1 : 1);
          select[i].setColor((i==current) ? Color.cyan : Color.red);
        }
    }
    public boolean action(Event ev, Object arg) {
        if (arg == select[0]) {
          /* Select Cutting Line or View on Axial Image */
          switch ( ev.id ) {
            case Event.MOUSE_DOWN : setCurrent(0); break;
            case Event.MOUSE_UP :
            case Event.MOUSE_DRAG : break;
            default: setCurrent(2);
          }
          return true;
        } else if (arg == select[1]) {
          /* Select Cutting Line or View on Sagittal Image */
          switch ( ev.id ) {
            case Event.MOUSE_DOWN : setCurrent(1); break;
            case Event.MOUSE_UP :
            case Event.MOUSE_DRAG : break;
            default: setCurrent(0);
          }
          return true;
        } else if (arg == select[2]) {
          /* Select Cutting Line or View on Coronal Image */
          switch ( ev.id ) {
            case Event.MOUSE_DOWN : setCurrent(2); break;
            case Event.MOUSE_UP :
            case Event.MOUSE_DRAG : break;
            default: setCurrent(1);
          }
          return true;
        } else if (arg == tagBtn[0]) {
          /* Select View on Axial Image */
          setCurrent(2);
          return true;
        } else if (arg == tagBtn[1]) {
          /* Select View on Sagittal Image */
          setCurrent(0);
          return true;
        } else if (arg == tagBtn[2]) {
          /* Select View on Coronal Image */
          setCurrent(1);
          return true;
        }
        return false;
    }
}
    
