/*
 * Stars Java Program
 */

import java.applet.*;
import java.awt.*;

public class Stars extends Applet {
    Image img;

    public Stars() { setBackground(Color.black);}

    public void init() {
        int i, x, y, d, count;
        Dimension sz = size();

        /* Create a blank Image */
        img = createImage(sz.width, sz.height);

        /* Get a Graphics Context associate with Image */
        Graphics offscr = img.getGraphics();

        /* Fill Image to Black */
        offscr.setColor(Color.black);
        offscr.fillRect(0, 0, sz.width, sz.height);

        /* Get Stars Density */
        count = (int)Math.sqrt(sz.width*sz.height);

        for (i=0; i<count; i++) {
          /* Get a Random Color */
          d = (int)(Math.random()*2+1);
          offscr.setColor(new Color((int)(Math.random()*255),
            (int)(Math.random()*255), (int)(Math.random()*255)));

          /* Get a Random (x, y) pair */
          x = (int)(Math.random()*sz.width);
          y = (int)(Math.random()*sz.height);

          /* Draw a pixel on image */
          offscr.fillOval(x, y, d, d);
        }

        /* Dispose Grahics Context */
        offscr.dispose();
    }

    /* this method will be called to repond a disclosure */
    public void paint(Graphics g) {
        g.drawImage(img, 0, 0, this);
    }
}
