
public class Test2 {
  
  public void forkNew() {
    forkThread fork1 = new forkThread("Thread-Test2.1");
    forkThread fork2 = new forkThread("Thread-Test2.2");
    
    fork1.start();
    listThreadsInfo(Thread.currentThread().getThreadGroup());
    
    fork2.start();
    listThreadsInfo(Thread.currentThread().getThreadGroup());
  }

  private void listThreadsInfo(ThreadGroup group) {
    if (group == null) return;
    Thread[] groupInfo;
    groupInfo   = new Thread[group.activeCount()];
    int iterate = group.enumerate(groupInfo, false);
    
    System.out.print("\n" + group + "\n");
    for (int i=0; i < iterate; i++) 
      System.out.print("    " + groupInfo[i] +"\n");
    
    listThreadsInfo(group.getParent());
  }

  public static void main(String[] args) {
    Test2 test = new Test2();
    test.forkNew();
  }

}
class forkThread extends Thread {
  public forkThread(String name) {
    super(name);
  }
  
  public void run() {
    try {
      sleep(250);
    } catch (java.lang.InterruptedException e) {
      e.printStackTrace();
    }	
  }  
}
