package sunw.demo.ImageEditor;

import java.beans.*;

/**
 *  ImageEditorBeanInfo.java
 *  <p>
  */
public class ImageEditorBeanInfo extends SimpleBeanInfo {
	
  public java.awt.Image getIcon(int iconType) {
    if (iconType == BeanInfo.ICON_COLOR_16x16) {
      java.awt.Image img = loadImage("faces.gif");
      return img;
    }
    if (iconType == BeanInfo.ICON_COLOR_32x32) {
      java.awt.Image img = loadImage("ImageScaleIconColor32.gif");
      return img;
    }
    if (iconType == BeanInfo.ICON_MONO_16x16) {
      java.awt.Image img = loadImage("ImageScaleIconMono16.gif");
      return img;
    }
    if (iconType == BeanInfo.ICON_MONO_32x32) {
      java.awt.Image img = loadImage("ImageScaleIconMono32.gif");
      return img;
    }
    return null;
  }
  
  public PropertyDescriptor[] getPropertyDescriptors() {
    try {
      PropertyDescriptor pd1 = new PropertyDescriptor("indicator",
						      ImageEditor.class);
      PropertyDescriptor pd2 = new PropertyDescriptor("imageLocation",
						      ImageEditor.class);
      PropertyDescriptor pd = new PropertyDescriptor("filterName",
						     ImageEditor.class);

      pd.setPropertyEditorClass(FilterNameEditor.class);
      PropertyDescriptor result[] = { pd1, pd2, pd };
      return result;
    } catch (Exception ex) {
      System.err.println("ImageEditorBeanInfo: unexpected exeption: " + ex);
      return null;
    }
  }
}
