package edu.syr.npac.webflow.connection;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.connection._st_connectionObject
<li> <b>Source File</b> edu/syr/npac/webflow/connection/_st_connectionObject.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::connection::connectionObject
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/connection/connectionObject:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/connection"
    interface connectionObject {
      void addItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      void addItemToTop(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module nextItem();
      ::edu::syr::npac::webflow::module::Module removeItem(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::module::Module insertItemBefore(
        in ::edu::syr::npac::webflow::module::Module arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void setPersistentConnection(
        in boolean arg0
      );
      boolean isPersistentConnection();
      void compute(
      )
      raises(
        ::edu::syr::npac::webflow::exception::webflowException
      );
      void setConnectionInfo(
        in string arg0
      );
      void addNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      void removeNode(
        in string arg0,
        in ::edu::syr::npac::webflow::module::Module arg1
      );
      ::edu::syr::npac::webflow::module::Module getNode(
        in string arg0
      );
      ::java::lang::Object invoke(
        in string arg0,
        in string arg1
      );
    };
</pre>
</p>
*/
public class _st_connectionObject extends org.omg.CORBA.portable.ObjectImpl implements edu.syr.npac.webflow.connection.connectionObject {
  protected edu.syr.npac.webflow.connection.connectionObject _wrapper = null;
  public edu.syr.npac.webflow.connection.connectionObject _this() {
    return this;
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/connection/connectionObject:1.0"
  };
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addItem(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public void addItem(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("addItem", true);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg0);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addItemToTop</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addItemToTop(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public void addItemToTop(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("addItemToTop", true);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg0);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::nextItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module nextItem();
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module nextItem() {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.module.Module _result;
    while(true) {
      _output = this._request("nextItem", true);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::removeItem</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module removeItem(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module removeItem(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.module.Module _result;
    while(true) {
      _output = this._request("removeItem", true);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg0);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::insertItemBefore</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module insertItemBefore(
      in ::edu::syr::npac::webflow::module::Module arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module insertItemBefore(
    edu.syr.npac.webflow.module.Module arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.module.Module _result;
    while(true) {
      _output = this._request("insertItemBefore", true);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg1);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::setPersistentConnection</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void setPersistentConnection(
      in boolean arg0
    );
  </pre>
  </p>
  */
  public void setPersistentConnection(
    boolean arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("setPersistentConnection", true);
      _output.write_boolean(arg0);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::isPersistentConnection</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    boolean isPersistentConnection();
  </pre>
  </p>
  */
  public boolean isPersistentConnection() {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    boolean _result;
    while(true) {
      _output = this._request("isPersistentConnection", true);
      try {
        _input = this._invoke(_output, null);
        _result = _input.read_boolean();
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::compute</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void compute(
    )
    raises(
      ::edu::syr::npac::webflow::exception::webflowException
    );
  </pre>
  </p>
  */
  public void compute(
  ) throws
    edu.syr.npac.webflow.exception.webflowException {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("compute", true);
      org.omg.CORBA.StringHolder _exception_id = new org.omg.CORBA.StringHolder();
      try {
        _input = this._invoke(_output, _exception_id);
        if(_exception_id.value != null) {
          if(_exception_id.value.equals(edu.syr.npac.webflow.exception.webflowExceptionHelper.id())) {
            throw edu.syr.npac.webflow.exception.webflowExceptionHelper.read(_input);
          }
          throw new org.omg.CORBA.MARSHAL
            ("Unexpected User Exception: " + _exception_id.value);
        }
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::setConnectionInfo</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void setConnectionInfo(
      in string arg0
    );
  </pre>
  </p>
  */
  public void setConnectionInfo(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("setConnectionInfo", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::addNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void addNode(
      in string arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public void addNode(
    java.lang.String arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("addNode", true);
      _output.write_string(arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg1);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::removeNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    void removeNode(
      in string arg0,
      in ::edu::syr::npac::webflow::module::Module arg1
    );
  </pre>
  </p>
  */
  public void removeNode(
    java.lang.String arg0,
    edu.syr.npac.webflow.module.Module arg1
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    while(true) {
      _output = this._request("removeNode", true);
      _output.write_string(arg0);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg1);
      try {
        _input = this._invoke(_output, null);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::getNode</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::edu::syr::npac::webflow::module::Module getNode(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module getNode(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.module.Module _result;
    while(true) {
      _output = this._request("getNode", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::connection::connectionObject::invoke</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/connection/connectionObject"
    ::java::lang::Object invoke(
      in string arg0,
      in string arg1
    );
  </pre>
  </p>
  */
  public java.lang.Object invoke(
    java.lang.String arg0,
    java.lang.String arg1
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    java.lang.Object _result;
    while(true) {
      _output = this._request("invoke", true);
      _output.write_string(arg0);
      _output.write_string(arg1);
      try {
        _input = this._invoke(_output, null);
        _result = (java.lang.Object)_input.read_estruct("java.lang.Object");
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
}
