/**
 *	Copyright (c) 1997-98 
 *	NorthEast Parallel Architectures Center, Syracuse University. 
 * All Rights Reserved. Permission to use, copy, modify, and distribute this
 * software and its documentation for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice and this paragraph appear in all
 * copies. Permission to incorporate this software into commercial products may
 * be obtained by contacting the NorthEast Parallel Architectures Center. 
 *
 * The software program and documentation are supplied "as is",
 * without any accompanying services from NPAC. NPAC does not
 * warrant that the operation of the program will be uninterrupted or
 * error-free. The end-user understands that the program was developed for
 * research purposes and is advised not to rely exclusively on the program for
 * any reason.
 *
 */

package edu.syr.npac.webflow.exception;

/** 
 * exceptionInfo, defines two methods which allows for adding additional 
 * information that occured during a computation, within the Webflow
 * runtime system.
 * 
 * @version     0.1  6 Oct 1998
 * @author      Shrideep Pallickara
 *
 */

public interface exceptionInfo {
  
  public void setAdditionalInfo();
  public String getAdditionalInfo(); 
}
