package edu.syr.npac.webflow.manager;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.manager._st_moduleManager
<li> <b>Source File</b> edu/syr/npac/webflow/manager/_st_moduleManager.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::manager::moduleManager
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/manager/moduleManager:1.0
</ul>
<b>IDL definition:</b>
<pre>
    #pragma prefix "edu/syr/npac/webflow/manager"
    interface moduleManager {
      typedef sequence&ltstring&gt sequence_of_string;
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
        in ::edu::syr::npac::webflow::module::Module arg0
      );
      ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
        in ::java::lang::Object arg0
      );
      Object getModuleHandle(
        in string arg0
      );
      ::edu::syr::npac::webflow::module::Module createTransientModule(
        in string arg0
      );
    };
</pre>
</p>
*/
public class _st_moduleManager extends org.omg.CORBA.portable.ObjectImpl implements edu.syr.npac.webflow.manager.moduleManager {
  protected edu.syr.npac.webflow.manager.moduleManager _wrapper = null;
  public edu.syr.npac.webflow.manager.moduleManager _this() {
    return this;
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/manager/moduleManager:1.0"
  };
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listModules</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listModules();
  </pre>
  </p>
  */
  public java.lang.String[] listModules() {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    java.lang.String[] _result;
    while(true) {
      _output = this._request("listModules", true);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listMethods</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listMethods(
      in ::edu::syr::npac::webflow::module::Module arg0
    );
  </pre>
  </p>
  */
  public java.lang.String[] listMethods(
    edu.syr.npac.webflow.module.Module arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    java.lang.String[] _result;
    while(true) {
      _output = this._request("listMethods", true);
      edu.syr.npac.webflow.module.ModuleHelper.write(_output, arg0);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::listZeroArgumentMethods</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::manager::moduleManager::sequence_of_string listZeroArgumentMethods(
      in ::java::lang::Object arg0
    );
  </pre>
  </p>
  */
  public java.lang.String[] listZeroArgumentMethods(
    java.lang.Object arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    java.lang.String[] _result;
    while(true) {
      _output = this._request("listZeroArgumentMethods", true);
      _output.write_estruct(arg0, "java.lang.Object");
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.manager.moduleManagerPackage.sequence_of_stringHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::getModuleHandle</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    Object getModuleHandle(
      in string arg0
    );
  </pre>
  </p>
  */
  public org.omg.CORBA.Object getModuleHandle(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    org.omg.CORBA.Object _result;
    while(true) {
      _output = this._request("getModuleHandle", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
        _result = _input.read_Object();
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::manager::moduleManager::createTransientModule</b>.
  <pre>
    #pragma prefix "edu/syr/npac/webflow/manager/moduleManager"
    ::edu::syr::npac::webflow::module::Module createTransientModule(
      in string arg0
    );
  </pre>
  </p>
  */
  public edu.syr.npac.webflow.module.Module createTransientModule(
    java.lang.String arg0
  ) {
    org.omg.CORBA.portable.OutputStream _output;
    org.omg.CORBA.portable.InputStream _input;
    edu.syr.npac.webflow.module.Module _result;
    while(true) {
      _output = this._request("createTransientModule", true);
      _output.write_string(arg0);
      try {
        _input = this._invoke(_output, null);
        _result = edu.syr.npac.webflow.module.ModuleHelper.read(_input);
      }
      catch(org.omg.CORBA.TRANSIENT _exception) {
        continue;
      }
      break;
    }
    return _result;
  }
}
