package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging.ImageInputModuleHelper
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/ImageInputModuleHelper.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageInputModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageInputModule : ::edu::syr::npac::webflow::module::Module {
      void setImageLocation(
        in string arg0
      );
      long getWidth();
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
abstract public class ImageInputModuleHelper {
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule narrow(org.omg.CORBA.Object object) {
    return narrow(object, false);
  }
  private static edu.syr.npac.webflow.module.imaging.ImageInputModule narrow(org.omg.CORBA.Object object, boolean is_a) {
    if(object == null) {
      return null;
    }
    if(object instanceof edu.syr.npac.webflow.module.imaging.ImageInputModule) {
      return (edu.syr.npac.webflow.module.imaging.ImageInputModule) object;
    }
    if(is_a || object._is_a(id())) {
      edu.syr.npac.webflow.module.imaging._st_ImageInputModule result = (edu.syr.npac.webflow.module.imaging._st_ImageInputModule)new edu.syr.npac.webflow.module.imaging._st_ImageInputModule();
      ((org.omg.CORBA.portable.ObjectImpl) result)._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      ((org.omg.CORBA.portable.ObjectImpl) result._this())._set_delegate
        (((org.omg.CORBA.portable.ObjectImpl) object)._get_delegate());
      return (edu.syr.npac.webflow.module.imaging.ImageInputModule) result._this();
    }
    return null;
  }
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule bind(org.omg.CORBA.ORB orb) {
    return bind(orb, null, null, null);
  }
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule bind(org.omg.CORBA.ORB orb, java.lang.String name) {
    return bind(orb, name, null, null);
  }
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule bind(org.omg.CORBA.ORB orb, java.lang.String name, java.lang.String host, org.omg.CORBA.BindOptions options) {
    return narrow(orb.bind(id(), name, host, options), true);
  }
  private static org.omg.CORBA.ORB _orb() {
    return org.omg.CORBA.ORB.init();
  }
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule read(org.omg.CORBA.portable.InputStream _input) {
    return edu.syr.npac.webflow.module.imaging.ImageInputModuleHelper.narrow(_input.read_Object(), true);
  }
  public static void write(org.omg.CORBA.portable.OutputStream _output, edu.syr.npac.webflow.module.imaging.ImageInputModule value) {
    _output.write_Object(value);
  }
  public static void insert(org.omg.CORBA.Any any, edu.syr.npac.webflow.module.imaging.ImageInputModule value) {
    org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
    write(output, value);
    any.read_value(output.create_input_stream(), type());
  }
  public static edu.syr.npac.webflow.module.imaging.ImageInputModule extract(org.omg.CORBA.Any any) {
    if(!any.type().equal(type())) {
      throw new org.omg.CORBA.BAD_TYPECODE();
    }
    return read(any.create_input_stream());
  }
  private static org.omg.CORBA.TypeCode _type;
  public static org.omg.CORBA.TypeCode type() {
    if(_type == null) {
      _type = _orb().create_interface_tc(id(), "ImageInputModule");
    }
    return _type;
  }
  public static java.lang.String id() {
    return "IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0";
  }
}
