package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging.ImageInputModuleOperations
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/ImageInputModuleOperations.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageInputModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageInputModule : ::edu::syr::npac::webflow::module::Module {
      void setImageLocation(
        in string arg0
      );
      long getWidth();
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
public interface ImageInputModuleOperations extends edu.syr.npac.webflow.module.ModuleOperations {
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::setImageLocation</b>.
  <pre>
    void setImageLocation(
      in string arg0
    );
  </pre>
  </p>
  */
  public void setImageLocation(
    java.lang.String arg0
  );
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getWidth</b>.
  <pre>
    long getWidth();
  </pre>
  </p>
  */
  public int getWidth();
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getHeight</b>.
  <pre>
    long getHeight();
  </pre>
  </p>
  */
  public int getHeight();
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getPixels</b>.
  <pre>
    ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
  </pre>
  </p>
  */
  public int[] getPixels();
}
