package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging._ImageInputModuleImplBase
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/_ImageInputModuleImplBase.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageInputModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageInputModule : ::edu::syr::npac::webflow::module::Module {
      void setImageLocation(
        in string arg0
      );
      long getWidth();
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
abstract public class _ImageInputModuleImplBase extends org.omg.CORBA.portable.Skeleton implements edu.syr.npac.webflow.module.imaging.ImageInputModule {
  protected edu.syr.npac.webflow.module.imaging.ImageInputModule _wrapper = null;
  public edu.syr.npac.webflow.module.imaging.ImageInputModule _this() {
    return this;
  }
  protected _ImageInputModuleImplBase(java.lang.String name) {
    super(name);
  }
  public _ImageInputModuleImplBase() {
  }
  public java.lang.String[] _ids() {
    return __ids;
  }
  private static java.lang.String[] __ids = {
    "IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0",
    "IDL:edu/syr/npac/webflow/module/Module:1.0"
  };
  public org.omg.CORBA.portable.MethodPointer[] _methods() {
    org.omg.CORBA.portable.MethodPointer[] methods = {
      new org.omg.CORBA.portable.MethodPointer("setImageLocation", 0, 0),
      new org.omg.CORBA.portable.MethodPointer("getWidth", 0, 1),
      new org.omg.CORBA.portable.MethodPointer("getHeight", 0, 2),
      new org.omg.CORBA.portable.MethodPointer("getPixels", 0, 3),
      new org.omg.CORBA.portable.MethodPointer("run", 1, 0),
      new org.omg.CORBA.portable.MethodPointer("destroy", 1, 1),
    };
    return methods;
  }
  public boolean _execute(org.omg.CORBA.portable.MethodPointer method, org.omg.CORBA.portable.InputStream input, org.omg.CORBA.portable.OutputStream output) {
    switch(method.interface_id) {
    case 0: {
      return edu.syr.npac.webflow.module.imaging._ImageInputModuleImplBase._execute(_this(), method.method_id, input, output); 
    }
    case 1: {
      return edu.syr.npac.webflow.module._ModuleImplBase._execute(_this(), method.method_id, input, output); 
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
  public static boolean _execute(edu.syr.npac.webflow.module.imaging.ImageInputModule _self, int _method_id, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.OutputStream _output) {
    switch(_method_id) {
    case 0: {
      java.lang.String arg0;
      arg0 = _input.read_string();
      _self.setImageLocation(arg0);
      return false;
    }
    case 1: {
      int _result = _self.getWidth();
      _output.write_long(_result);
      return false;
    }
    case 2: {
      int _result = _self.getHeight();
      _output.write_long(_result);
      return false;
    }
    case 3: {
      int[] _result = _self.getPixels();
      edu.syr.npac.webflow.module.imaging.ImageInputModulePackage.sequence_of_longHelper.write(_output, _result);
      return false;
    }
    }
    throw new org.omg.CORBA.MARSHAL();
  }
}
