package edu.syr.npac.webflow.module.imaging;
/**
<p>
<ul>
<li> <b>Java Class</b> edu.syr.npac.webflow.module.imaging._tie_ImageInputModule
<li> <b>Source File</b> edu/syr/npac/webflow/module/imaging/_tie_ImageInputModule.java
<li> <b>IDL Absolute Name</b> ::edu::syr::npac::webflow::module::imaging::ImageInputModule
<li> <b>Repository Identifier</b> IDL:edu/syr/npac/webflow/module/imaging/ImageInputModule:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface ImageInputModule : ::edu::syr::npac::webflow::module::Module {
      void setImageLocation(
        in string arg0
      );
      long getWidth();
      long getHeight();
      typedef sequence&ltlong&gt sequence_of_long;
      ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
    };
</pre>
</p>
*/
public class _tie_ImageInputModule extends edu.syr.npac.webflow.module.imaging._ImageInputModuleImplBase {
  private edu.syr.npac.webflow.module.imaging.ImageInputModuleOperations _delegate;
  public _tie_ImageInputModule(edu.syr.npac.webflow.module.imaging.ImageInputModuleOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_ImageInputModule(edu.syr.npac.webflow.module.imaging.ImageInputModuleOperations delegate) {
    this._delegate = delegate;
  }
  public edu.syr.npac.webflow.module.imaging.ImageInputModuleOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::setImageLocation</b>.
  <pre>
    void setImageLocation(
      in string arg0
    );
  </pre>
  </p>
  */
  public void setImageLocation(
    java.lang.String arg0
  ) {
    this._delegate.setImageLocation(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getWidth</b>.
  <pre>
    long getWidth();
  </pre>
  </p>
  */
  public int getWidth() {
    return this._delegate.getWidth(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getHeight</b>.
  <pre>
    long getHeight();
  </pre>
  </p>
  */
  public int getHeight() {
    return this._delegate.getHeight(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::imaging::ImageInputModule::getPixels</b>.
  <pre>
    ::edu::syr::npac::webflow::module::imaging::ImageInputModule::sequence_of_long getPixels();
  </pre>
  </p>
  */
  public int[] getPixels() {
    return this._delegate.getPixels(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::Module::run</b>.
  <pre>
    void run();
  </pre>
  </p>
  */
  public void run() {
    this._delegate.run(
    );
  }
  /**
  <p>
  Operation: <b>::edu::syr::npac::webflow::module::Module::destroy</b>.
  <pre>
    void destroy();
  </pre>
  </p>
  */
  public void destroy() {
    this._delegate.destroy(
    );
  }
}
