// MuProtocol.java 
// common constant for server and client 
/**
* This is part of the source code needed for building a Collabratised
* VRML World using JSDA.
* The files needed are 
* Server-Side :: 
* VRServer.java - This is the Virtual World Server
* MuProtocol.java - This contains various defined constants used throughout
* 
* Client-side ::
* VRClient.java - 
* VRUser.java - The Java Script
* VRConsumer.java
* MuProtocol.java - This contains various defined constants used throughout
* 
* @author : Shrideep Pallickara
* @advisor: Dr. Wojtek Furmanski
* @date   : 26/Mar - 1997.
*/


public interface  MuProtocol { 
   public final static int PORT = 4461; 
   public final static int MOVE = 1; 
   public final static int ROTATION = 2; 

   static final boolean VRConsumer_Debug = false;
   static final boolean VRServer_Debug   = false;
   static final boolean VRUser_Debug     = false;
   static final boolean VRUserApp_Debug  = false;
}
