/**
* This is part of the source code needed for building a Collabratised
* VRML World using JSDA.
* The files needed are 
* Server-Side :: 
* VRServer.java - This is the Virtual World Server
* MuProtocol.java - This contains various defined constants used throughout
* 
* Client-side ::
* VRClient.java - 
* VRUser.java - The Java Script
* VRConsumer.java
* MuProtocol.java - This contains various defined constants used throughout
* 
* @author : Shrideep Pallickara
* @advisor: Dr. Wojtek Furmanski
* @date   : 26/Mar - 1997.
*/
import SharedData.*;


public class
VRClient implements Client {

    protected String name;

    public
    VRClient(String name) {
        this.name = name;
    }


    public String
    authenticate(String challenge) {
        System.out.println("VRClient: authenticate."); 
	return((String) null);
    }


    public String
    getName() {
        return(name);
    }


    public void
    clientChanged(ClientEvent event) {
        System.out.println("VRClient: clientChanged.");
    }
}
