/*
 *  File:  ColorBoxes2.java
 *
 *  Display built-in colors with labels
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class ColorBoxes2 extends Applet {

   public void paint( Graphics g ) {
      
      // Draw the first row of color boxes:
      g.setColor( Color.black );
      g.fillRect( 10, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "black", 10, 10 );
      g.setColor( Color.blue );
      g.fillRect( 80, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "blue", 80, 10 );
      g.setColor( Color.cyan );
      g.fillRect( 150, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "cyan", 150, 10 );
      g.setColor( Color.darkGray );
      g.fillRect( 220, 10, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "darkGray", 220, 10 );
      
      // Draw the second row of color boxes:
      g.setColor( Color.gray );
      g.fillRect( 10, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "gray", 10, 80 );
      g.setColor( Color.green );
      g.fillRect( 80, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "green", 80, 80 );
      g.setColor( Color.lightGray );
      g.fillRect( 150, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "lightGray", 150, 80 );
      g.setColor( Color.magenta );
      g.fillRect( 220, 80, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "magenta", 220, 80 );
      
      // Draw the third row of color boxes:
      g.setColor( Color.orange );
      g.fillRect( 10, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "orange", 10, 150 );
      g.setColor( Color.pink );
      g.fillRect( 80, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "pink", 80, 150 );
      g.setColor( Color.red );
      g.fillRect( 150, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "red", 150, 150 );
      g.setColor( Color.white );
      g.fillRect( 220, 150, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "white", 220, 150 );
      
      // Draw the fourth row of color boxes:
      g.setColor( Color.yellow );
      g.fillRect( 10, 220, 50, 50 );
      g.setColor( Color.black );
      g.drawString( "yellow", 10, 220 );
      
   }
   
}
