/*
 *  File:  TextAreaDemo.java
 *
 *  Create an noneditable text area
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.awt.TextArea;

public class TextAreaDemo extends java.applet.Applet {

  private TextArea verse;

  public void init() {
    setBackground( java.awt.Color.white );

    String str = 
      "Once upon a midnight dreary, while I pondered, weak and weary,\n" +
      "Over many a quaint and curious volume of forgotten lore,\n" +
      "While I nodded, nearly napping, suddenly there came a tapping,\n" +
      "As of some one gently rapping, rapping at my chamber door.\n" +
      "\"'Tis some visitor,\" I muttered, \"tapping at my chamber door-\n" +
      "Only this, and nothing more.\"\n\n" +
      "Ah, distinctly I remember it was in the bleak December,\n" +
      "And each separate dying ember wrought its ghost upon the floor.\n" +
      "Eagerly I wished the morrow;- vainly I had sought to borrow\n" +
      "From my books surcease of sorrow- sorrow for the lost Lenore-\n" +
      "For the rare and radiant maiden whom the angels name Lenore-\n" +
      "Nameless here for evermore.";
      
    verse = new TextArea( str, 7, 60, TextArea.SCROLLBARS_VERTICAL_ONLY );
    verse.setEditable( false );

    add(verse);
  }
  
}
