/*
 *  File:  OctagonTest2.java
 *
 *  Drawing a regular octagon
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Polygon;
import java.awt.Color;

public class OctagonTest2 extends Applet {

   // create references to two polygons:
   private Polygon p1, p2;
   
   public void init() {
   
      // instantiate a polygon object:
      p1 = new Polygon();

      // add points to make a square:
      p1.addPoint(  25,  25 );
      p1.addPoint( 175,  25 );
      p1.addPoint( 175, 175 );
      p1.addPoint(  25, 175 );

      // instantiate a polygon object:
      p2 = new Polygon();

      // add points to make a regular octagon:
      p2.addPoint(  69,  25 );
      p2.addPoint( 131,  25 );
      p2.addPoint( 175,  69 );
      p2.addPoint( 175, 131 );
      p2.addPoint( 131, 175 );
      p2.addPoint(  69, 175 );
      p2.addPoint(  25, 131 );
      p2.addPoint(  25,  69 );

   }
   
   public void paint( Graphics g ) {

      // draw a square:
      g.setColor( Color.yellow );
      g.drawPolygon( p1 );

      // draw a octagon:
      g.setColor( Color.red );
      g.drawPolygon( p2 );

   }
   
}
