/*
 *  File:  ArcTest.java
 *
 *  Draw some filled and unfilled arcs
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;

public class ArcTest extends Applet {

   public void paint( Graphics g ) {
   
      // draw a half ellipse: 
      g.drawArc( 15, 15, 80, 60, 0, 180 );

      // draw a filled half ellipse:
      g.fillArc( 15, 80, 80, 60, 0, -180 );

      // draw three-quarters of a filled circle:
      g.fillArc( 110, 55, 60, 60, 0, 270 );

      // draw a quarter of a circle:
      g.drawArc( 110, 55, 60, 60, 0, -90 );

      // draw a large, filled ellipse:
      g.fillArc( 190, 15, 80, 140, 0, 360 );
      
   }
   
}
