/*
 *  File:  ArcTest2.java
 *
 *  Draw some filled and unfilled arcs,
 *  plus a large, blue pacman.
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class ArcTest2 extends Applet {

   public void paint( Graphics g ) {
   
      // draw a half ellipse: 
      g.drawArc( 15, 15, 80, 60, 0, 180 );

      // draw a filled half ellipse:
      g.fillArc( 15, 80, 80, 60, 0, -180 );

      // draw three-quarters of a filled circle:
      g.fillArc( 110, 55, 60, 60, 0, 270 );

      // draw a quarter of a circle:
      g.drawArc( 110, 55, 60, 60, 0, -90 );

      // draw a large, blue pacman:
      g.setColor( Color.blue );
      g.fillArc( 190, 15, 80, 140, 240, 240 );
      
   }
   
}
