/*
 *  File:  RectTest3.java
 *
 *  Draw a rectangle and a filled rectangle.
 *  Draw another rectangle inside the first rectangle.
 *  Clear a rectangular area from the filled rectangle.
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;

public class RectTest3 extends Applet {

   public void paint( Graphics g ) {
   
      // draw a rectangle at point ( 20, 15 ):
      g.drawRect( 20, 15, 100, 100 );

      // draw another rectangle inside the previous rectangle:
      g.drawRect( 40, 35, 60, 60 );

      // draw a filled rectangle at point ( 140, 15 ):
      g.fillRect( 140, 15, 100, 100 );

      // clear a rectangular area from the previous filled rectangle:
      g.clearRect( 160, 35, 60, 60 );
      
   }
   
}
