/*
 *  File:  ColorBox1.java
 *
 *  Drawing random color boxes
 *
 *  Copyright:  Northeast Parallel Architectures Center
 */

import java.awt.Color;
import java.awt.Graphics;

public class ColorBox1 extends java.applet.Applet {

  int i, j;
  int m, n;
  
  int ColorArray_R[][] = new int[12][12];
  int ColorArray_G[][] = new int[12][12];
  int ColorArray_B[][] = new int[12][12];
  
  public void init() {
    for (int i=0; i<12; i++) {
      for (int j=0; j<12; j++) {
        ColorArray_R[i][j] = (int)Math.floor(Math.random()*256);
        ColorArray_G[i][j] = (int)Math.floor(Math.random()*256);
        ColorArray_B[i][j] = (int)Math.floor(Math.random()*256);
      }
    }
  }

  
  public void paint(Graphics g) {
    i=0; j=0;
    for (i=0; i<12; i++) {
      for (j=0; j<12; j++) {
        g.setColor(new Color(ColorArray_R[i][j], ColorArray_G[i][j], ColorArray_B[i][j]));
        g.fillRect(10+i*30, 10+j*30, 25, 25);
        g.setColor(Color.black);
        g.drawRect(10+i*30, 10+j*30, 25, 25);
      }
    }
  }
}
