/*
 *  File:  RectangleTest.java
 *
 *  Rotate a rectangle
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Color;

public class RectangleTest extends Applet {

   // create a reference to a rectangle:
   private Rectangle rectangle;
   
   // rectangle parameters:
   private int x, y, w, h;
   
   // constant number of rotations:
   private final int N = 8;
   
   // rotation angle:
   private final double angle = 2 * Math.PI/N;
      
   public void init() {
   
      // top left-hand corner of the rectangle:
      x = 100; y = 100;
      // width and height of the rectangle:
      w =  75; h =  50;
      
   }
   
   public void paint( Graphics g ) {

      g.setColor( Color.red );

      double theta = 0;
      for ( int i = 0; i < N; i++ ) {
         theta += angle;
         rectangle = new Rectangle( x, y, w, h, theta );
         rectangle.draw( g );
      }

   }
   
}
