/*
 *  File:  SquareTest.java
 *
 *  Draw a square
 *
 *  Copyright:  Northeast Parallel Architectures Center
 *  
 */

import java.applet.Applet;
import java.awt.Graphics;

public class SquareTest extends Applet {

   // create a reference to a square:
   private Square square;
   
   // square parameters:
   private int x, y, length = 20;      
   
   public void paint( Graphics g ) {

      // draw an 8x8 checkerboard:
      y = 0;
      for ( int i = 0; i < 8; i++ ) {
         x = 0; y += length;
         for ( int j = 0; j < 8; j++ ) {
            x += length;
            square = new Square( x, y, length );
            if ( (i + j) % 2 == 0 ) {
               square.draw( g );
            } else {
               square.fill( g );
            }
         }
      }

   }
   
}
