import java.lang.Integer;
import java.lang.String;

//////////////////////////////////////////////////////////////////////////////////////////////////////// 
//Title      :Test Program 
//Description:
//            This is a test program for the class Rational.Class Rational provides memeber functions for 
//            performing arithmetic operations on Rational numbers.This test program allow the user to 
//            enter Rational numbers.It uses the functions of the Rational class to determine the maximum 
//            and sum of the Rational numbers entered by the user.It converts each rational number to its 
//            lowest fraction and prints each Rational number as a string using the function toString of 
//            the Rational class. 
//Inputs     :The numerator and denominator of each rational element as enterd by the user
//Outputs    :The List of all rational elements entered by the user.Each element is printed as a string
//           :The sum of all rational elements entered by the user
//           :The maximum of all rational elements entered by the user
//Local 
//  Variables:
//            rationale,rationstr-instances of Rational class
//            int RationalArray[]-the array which holds the rational numbers
//            int MAXARRAY-number of rational numbers to be entered by the user
//            int ACTUALMAXARRAY-The totla no of numbers to be entered by the user.
//            int ArrayIndex-position of Rational element in the array
//            int counter-counts the number of Rational elements
//            SumofRationalElements-instance of rational class-holds the sum of all rational elements
//                      entered by the user
//            MaxofRationalElements-instance of Rational class-holds the maximum of all rational elements 
//                      entered by the user
/////////////////////////////////////////////////////////////////////////////////////////////////////////     
public class RationalTest{ 
	static Rational rationale,rationstr;		//instances of Rational class
	public static void main( String[] args){
	
          System.out.println("\nSample program to perform arithmetic on Rational numbers");
	  System.out.println("========================================================\n");
 
         //create instances of the Rational class
	 rationale=new Rational();
	 rationstr=new Rational();
	 
         //declare the array which holds the rational numbers
	 int RationalArray[];

         //read the number-MAXARRAY- of rational numbers to be entered by the user
	 int MAXARRAY = Console.readInt("Enter the number of rational numbers you will be entering  : ");
	 
         //The total no. of numbers which is the user enters is twice (Numerator and denominator) the ACTUALMAXARRAY
         int ACTUALMAXARRAY=2*MAXARRAY;
	 RationalArray = new int[2*MAXARRAY];		//declare the size of the array
 		
	 int ArrayIndex,counter=1;					
	 //Fill in array with the input numerator and denominator
	 for(ArrayIndex=0;ArrayIndex<ACTUALMAXARRAY;ArrayIndex+=2){	
	    
	    //RationalArray[ArrayIndex}-holds the numerator
	    RationalArray[ArrayIndex]=Console.readInt("Enter the Numerator of the Rational Element "+counter+":");
	    
	    // RationalArray[ArrayIndex+1]-holds the denominator
	    RationalArray[ArrayIndex+1]=Console.readInt("Enter the Denominator of the Rational Element "+counter+":");
	    
	     //check if denominator is zero
            while(RationalArray[ArrayIndex+1]==0){
                System.out.println("Denominator cannot be zero\n");
                RationalArray[ArrayIndex+1]=Console.readInt("Enter the Denominator of the Rational Element "+counter+":"); 
            }  
	    System.out.println(""); 
            counter++;
	 
	 }
		
	 //SumofRationalElements - instance of rational class-holds the sum of the rational elements
	 Rational SumofRationalElements=new Rational(0,1);
	 
         //MaxofRationalElements - instance of rational class-holds the maximum of the rational elements
	 Rational MaxofRationalElements=new Rational(0,1);
         

         System.out.println("\n\nThe Rational Elements you have entered are: ");
         System.out.println("================================================");
                 
	 //parse through each rational element of the array
	 for(ArrayIndex=0;ArrayIndex<ACTUALMAXARRAY;ArrayIndex+=2){
	         //set the numerator and denominator of the Rational object-rationstr-to the input numerator 
	         // and denominator

                 rationstr.getnumdenom(RationalArray[ArrayIndex],RationalArray[ArrayIndex+1]);

	         //Display each rational number entered by the user,in the form a of a string
		 rationale.toString(rationstr);
		
		 //Find the sum of all elements of the array
		 SumofRationalElements=rationale.Addition(SumofRationalElements,rationstr);
		  
		 //Find the maximum of all rational elements by comparing all elements
		 MaxofRationalElements=rationale.Comparision(rationstr,MaxofRationalElements);
                 

	 }
	 //Display the sum-SumofRationalElements- of the Rational elements entered by the user
	        System.out.println("\n The sum of the rational Elements is  : ");
		System.out.println("==========================================");

		rationale.toString(SumofRationalElements);
	 
         //Display the Maximum-MaxofRationalElements- of the Rational elements entered by the user
	        System.out.println("\nThe Maximum of the rational Elements is  : ");
                System.out.println("=============================================");
		rationale.toString(MaxofRationalElements);

	}
}



